
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega328P
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : float, width, precision
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 512 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega328P
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2303
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0100
	.EQU __SRAM_END=0x08FF
	.EQU __DSTACK_SIZE=0x0200
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _LCD_X=R4
	.DEF _LCD_Y=R3
	.DEF _out=R5

;GPIOR0 INITIALIZATION VALUE
	.EQU __GPIOR0_INIT=0x00

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_image0:
	.DB  0x0,0xFE,0x2,0x2,0x2,0x2,0x2,0x2
	.DB  0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x2
	.DB  0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x2
	.DB  0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x2
	.DB  0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x2
	.DB  0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x2
	.DB  0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x2
	.DB  0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x2
	.DB  0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x2
	.DB  0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x2
	.DB  0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x2
	.DB  0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x2
	.DB  0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x2
	.DB  0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x2
	.DB  0x2,0x2,0x2,0x2,0x2,0x2,0x2,0x2
	.DB  0x2,0x2,0x2,0x2,0x2,0x2,0xFE,0x0
	.DB  0x0,0xFF,0x0,0x0,0x0,0x0,0x0,0xFF
	.DB  0xFF,0x7,0x1E,0x38,0x60,0xC0,0x60,0x30
	.DB  0x1E,0x7,0xFF,0xFF,0x0,0x0,0xFF,0xFF
	.DB  0x83,0x83,0x83,0x83,0x83,0x83,0x83,0x0
	.DB  0x0,0xFC,0xFC,0x6,0x3,0x3,0x83,0x83
	.DB  0x83,0x8F,0x8E,0x0,0x0,0xF0,0xF8,0x8C
	.DB  0x84,0x86,0x83,0x83,0x83,0x86,0x8C,0x8C
	.DB  0xF8,0xF0,0x0,0x0,0x80,0x80,0x80,0x80
	.DB  0x80,0x80,0x0,0x0,0xF0,0xF8,0x9C,0x8C
	.DB  0x86,0x87,0x83,0x83,0x87,0x8E,0x9C,0xF8
	.DB  0xF0,0x0,0x0,0xFF,0xFF,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0xFF,0xFF
	.DB  0x0,0x0,0xFC,0xFE,0x83,0x83,0x83,0x83
	.DB  0x83,0x83,0x83,0xFE,0x3C,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0xFF,0x0
	.DB  0x0,0xFF,0x0,0x0,0x0,0x0,0x0,0xFF
	.DB  0xFF,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0xFF,0xFF,0x0,0x0,0xFF,0xFF
	.DB  0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0x0
	.DB  0x0,0x1F,0x3F,0x70,0xE0,0xC0,0xC1,0xE1
	.DB  0x31,0x3F,0xF,0x0,0x0,0xFF,0xFF,0x1
	.DB  0x1,0x1,0x1,0x1,0x1,0x1,0x1,0x1
	.DB  0xFF,0xFF,0x0,0x0,0x1,0x1,0x1,0x1
	.DB  0x1,0x1,0x0,0x0,0xFF,0xFF,0x1,0x1
	.DB  0x1,0x1,0x1,0x1,0x1,0x1,0x1,0xFF
	.DB  0xFF,0x0,0x0,0x3,0xF,0x18,0x30,0x60
	.DB  0xC0,0x80,0x80,0xC0,0x70,0x18,0xF,0x3
	.DB  0x0,0x0,0xFF,0xFF,0x1,0x1,0x3,0x7
	.DB  0xD,0x39,0x71,0xC0,0x80,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0xFF,0x0
	.DB  0x0,0xFF,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x80,0x80,0xC0,0xC0,0xC0,0xC0,0xC0
	.DB  0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0
	.DB  0x80,0x80,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x20,0x60,0xC0,0xC0,0x80,0x80,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80
	.DB  0xC0,0xC0,0x20,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0xFF,0x0
	.DB  0x0,0xFF,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x80,0xE0,0xF8,0x3C,0x1E
	.DB  0x6,0x3,0xC1,0x61,0x20,0x20,0x60,0xC0
	.DB  0x0,0x0,0x0,0x80,0xC0,0x41,0x41,0xC1
	.DB  0x3,0x3,0x3,0x6,0x1C,0x18,0x38,0x70
	.DB  0xE0,0x80,0x0,0x0,0x0,0x0,0x0,0x1
	.DB  0x3,0x6,0xC,0x18,0x30,0xE0,0xC0,0xC0
	.DB  0xC0,0xE0,0x30,0x18,0xC,0x6,0x3,0x1
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x1,0x3,0x7
	.DB  0xF,0xE,0x1C,0x3C,0x78,0x78,0xF0,0xF0
	.DB  0xE0,0xC0,0xC0,0x80,0x80,0x0,0x0,0x0
	.DB  0x0,0x0,0x80,0x80,0xC0,0xE0,0xE0,0xF0
	.DB  0xF8,0xF8,0xFC,0xFC,0x7E,0x1F,0xF,0x3
	.DB  0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0xFF,0x0
	.DB  0x0,0xFF,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0xF8,0xFF,0x3,0x0,0x0,0x0
	.DB  0x80,0x87,0x8D,0xC,0x9,0xC,0x6,0x3
	.DB  0x0,0x0,0x1F,0x11,0x12,0x18,0xC,0x87
	.DB  0x80,0x0,0x0,0x0,0x0,0x0,0x0,0xE0
	.DB  0x7F,0xF,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0xFF,0xFF,0x3,0x3,0x3,0x3,0x3,0x3
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x3
	.DB  0xFF,0xFF,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x80,0x81
	.DB  0xC3,0xE7,0xE7,0xFF,0xFF,0xFF,0xFF,0xFE
	.DB  0xFE,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	.DB  0xCF,0x87,0x83,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0xFF,0x0
	.DB  0x0,0xFF,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0xF,0x1F,0x7C,0xF8,0xC0,0x80
	.DB  0x81,0x87,0x8D,0x8B,0xA,0x1A,0x16,0x14
	.DB  0x14,0x14,0x14,0x14,0x16,0x1B,0xD,0x7
	.DB  0x81,0x80,0xC0,0xE0,0x78,0x3E,0x1F,0x7
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0xFF,0xFF,0x80,0x80,0x80,0x80,0x80,0x80
	.DB  0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80
	.DB  0xFF,0xFF,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x80,0xC0,0xC0,0xE0,0xF0,0xF0
	.DB  0xF8,0xFC,0xFC,0xFE,0xFF,0xFF,0xFF,0xFF
	.DB  0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
	.DB  0xFF,0xBF,0x9F,0x8F,0x87,0x8F,0x9F,0xBF
	.DB  0xBF,0xFF,0xFF,0xFF,0xFF,0xFE,0xFE,0xFC
	.DB  0xFC,0xF8,0xF0,0xF0,0xE0,0xE0,0xC0,0xC0
	.DB  0x80,0x0,0x0,0x0,0x0,0x0,0xFF,0x0
	.DB  0x0,0x7F,0x40,0x40,0x40,0x40,0x40,0x40
	.DB  0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x41
	.DB  0x43,0x43,0x43,0x43,0x43,0x43,0x43,0x43
	.DB  0x43,0x43,0x43,0x43,0x43,0x43,0x43,0x43
	.DB  0x41,0x41,0x41,0x40,0x40,0x40,0x40,0x40
	.DB  0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40
	.DB  0x41,0x41,0x41,0x41,0x41,0x41,0x41,0x41
	.DB  0x41,0x41,0x41,0x41,0x41,0x41,0x41,0x41
	.DB  0x41,0x41,0x40,0x40,0x40,0x40,0x40,0x40
	.DB  0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40
	.DB  0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40
	.DB  0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40
	.DB  0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40
	.DB  0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40
	.DB  0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40
	.DB  0x40,0x40,0x40,0x40,0x40,0x40,0x7F,0x0
	.DB  0x0,0x0
_LCD_Buffer:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x5F
	.DB  0x0,0x0,0x0,0x7,0x0,0x7,0x0,0x14
	.DB  0x7F,0x14,0x7F,0x14,0x24,0x2A,0x7F,0x2A
	.DB  0x12,0x23,0x13,0x8,0x64,0x62,0x36,0x49
	.DB  0x55,0x22,0x50,0x0,0x5,0x3,0x0,0x0
	.DB  0x0,0x1C,0x22,0x41,0x0,0x0,0x41,0x22
	.DB  0x1C,0x0,0x14,0x8,0x3E,0x8,0x14,0x8
	.DB  0x8,0x3E,0x8,0x8,0x0,0x50,0x30,0x0
	.DB  0x0,0x8,0x8,0x8,0x8,0x8,0x0,0x60
	.DB  0x60,0x0,0x0,0x20,0x10,0x8,0x4,0x2
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x5F
	.DB  0x0,0x0,0x0,0x7,0x0,0x7,0x0,0x14
	.DB  0x7F,0x14,0x7F,0x14,0x24,0x2A,0x7F,0x2A
	.DB  0x12,0x23,0x13,0x8,0x64,0x62,0x36,0x49
	.DB  0x55,0x22,0x50,0x0,0x5,0x3,0x0,0x0
	.DB  0x0,0x1C,0x22,0x41,0x0,0x0,0x41,0x22
	.DB  0x1C,0x0,0x14,0x8,0x3E,0x8,0x14,0x8
	.DB  0x8,0x3E,0x8,0x8,0x0,0x50,0x30,0x0
	.DB  0x0,0x8,0x8,0x8,0x8,0x8,0x0,0x60
	.DB  0x60,0x0,0x0,0x20,0x10,0x8,0x4,0x2
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x5F
	.DB  0x0,0x0,0x0,0x7,0x0,0x7,0x0,0x14
	.DB  0x7F,0x14,0x7F,0x14,0x24,0x2A,0x7F,0x2A
	.DB  0x12,0x23,0x13,0x8,0x64,0x62,0x36,0x49
	.DB  0x55,0x22,0x50,0x0,0x5,0x3,0x0,0x0
	.DB  0x0,0x1C,0x22,0x41,0x0,0x0,0x41,0x22
	.DB  0x1C,0x0,0x14,0x8,0x3E,0x8,0x14,0x8
	.DB  0x8,0x3E,0x8,0x8,0x0,0x50,0x30,0x0
	.DB  0x0,0x8,0x8,0x8,0x8,0x8,0x0,0x60
	.DB  0x60,0x0,0x0,0x20,0x10,0x8,0x4,0x2
	.DB  0x3E,0x51,0x49,0x45,0x3E,0x0,0x42,0x7F
	.DB  0x40,0x0,0x42,0x61,0x51,0x49,0x46,0x21
	.DB  0x41,0x45,0x4B,0x31,0x18,0x14,0x12,0x7F
	.DB  0x10,0x27,0x45,0x45,0x45,0x39,0x3C,0x4A
	.DB  0x49,0x49,0x30,0x1,0x71,0x9,0x5,0x3
	.DB  0x36,0x49,0x49,0x49,0x36,0x6,0x49,0x49
	.DB  0x29,0x1E,0x0,0x36,0x36,0x0,0x0,0x0
	.DB  0x56,0x36,0x0,0x0,0x8,0x14,0x22,0x41
	.DB  0x0,0x14,0x14,0x14,0x14,0x14,0x0,0x41
	.DB  0x22,0x14,0x8,0x2,0x1,0x51,0x9,0x6
	.DB  0x32,0x49,0x79,0x41,0x3E,0x7E,0x11,0x11
	.DB  0x11,0x7E,0x7F,0x49,0x49,0x49,0x36,0x3E
	.DB  0x41,0x41,0x41,0x22,0x7F,0x41,0x41,0x22
	.DB  0x1C,0x7F,0x49,0x49,0x49,0x41,0x7F,0x9
	.DB  0x9,0x9,0x1,0x3E,0x41,0x49,0x49,0x7A
	.DB  0x7F,0x8,0x8,0x8,0x7F,0x0,0x41,0x7F
	.DB  0x41,0x0,0x20,0x40,0x41,0x3F,0x1,0x7F
	.DB  0x8,0x14,0x22,0x41,0x7F,0x40,0x40,0x40
	.DB  0x40,0x7F,0x2,0xC,0x2,0x7F,0x7F,0x4
	.DB  0x8,0x10,0x7F,0x3E,0x41,0x41,0x41,0x3E
	.DB  0x7F,0x9,0x9,0x9,0x6,0x3E,0x41,0x51
	.DB  0x21,0x5E,0x7F,0x9,0x19,0x29,0x46,0x46
	.DB  0x49,0x49,0x49,0x31,0x1,0x1,0x7F,0x1
	.DB  0x1,0x3F,0x40,0x40,0x40,0x3F,0x1F,0x20
	.DB  0x40,0x20,0x1F,0x3F,0x40,0x38,0x40,0x3F
	.DB  0x63,0x14,0x8,0x14,0x63,0x7,0x8,0x70
	.DB  0x8,0x7,0x61,0x51,0x49,0x45,0x43,0x0
	.DB  0x7F,0x41,0x41,0x0,0x2,0x4,0x8,0x10
	.DB  0x20,0x0,0x41,0x41,0x7F,0x0,0x4,0x2
	.DB  0x1,0x2,0x4,0x40,0x40,0x40,0x40,0x40
	.DB  0x0,0x1,0x2,0x4,0x0,0x20,0x54,0x54
	.DB  0x54,0x78,0x7F,0x48,0x44,0x44,0x38,0x38
	.DB  0x44,0x44,0x44,0x20,0x38,0x44,0x44,0x48
	.DB  0x7F,0x38,0x54,0x54,0x54,0x18,0x8,0x7E
	.DB  0x9,0x1,0x2,0xC,0x52,0x52,0x52,0x3E
	.DB  0x7F,0x8,0x4,0x4,0x78,0x0,0x44,0x7D
	.DB  0x40,0x0,0x20,0x40,0x44,0x3D,0x0,0x7F
	.DB  0x10,0x28,0x44,0x0,0x0,0x41,0x7F,0x40
	.DB  0x0,0x7C,0x4,0x18,0x4,0x78,0x7C,0x8
	.DB  0x4,0x4,0x78,0x38,0x44,0x44,0x44,0x38
	.DB  0x7C,0x14,0x14,0x14,0x8,0x8,0x14,0x14
	.DB  0x18,0x7C,0x7C,0x8,0x4,0x4,0x8,0x8
	.DB  0x54,0x54,0x54,0x20,0x4,0x3F,0x44,0x40
	.DB  0x20,0x3C,0x40,0x40,0x20,0x7C,0x1C,0x20
	.DB  0x40,0x20,0x1C,0x3C,0x40,0x30,0x40,0x3C
	.DB  0x44,0x28,0x10,0x28,0x44,0xC,0x50,0x50
	.DB  0x50,0x3C,0x44,0x64,0x54,0x4C,0x44,0x0
	.DB  0x8,0x36,0x41,0x0,0x0,0x0,0x7F,0x0
	.DB  0x0,0x0,0x41,0x36,0x8,0x0,0x10,0x8
	.DB  0x8,0x10,0x8,0x78,0x46,0x41,0x46,0x78
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x5F
	.DB  0x0,0x0,0x0,0x7,0x0,0x7,0x0,0x14
	.DB  0x7F,0x14,0x7F,0x14,0x24,0x2A,0x7F,0x2A
	.DB  0x12,0x23,0x13,0x8,0x64,0x62,0x36,0x49
	.DB  0x55,0x22,0x50,0x0,0x5,0x3,0x0,0x0
	.DB  0x0,0x1C,0x22,0x41,0x0,0x0,0x41,0x22
	.DB  0x1C,0x0,0x14,0x8,0x3E,0x8,0x14,0x8
	.DB  0x8,0x3E,0x8,0x8,0x0,0x50,0x30,0x0
	.DB  0x0,0x8,0x8,0x8,0x8,0x8,0x0,0x60
	.DB  0x60,0x0,0x0,0x20,0x10,0x8,0x4,0x2
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x5F
	.DB  0x0,0x0,0x0,0x7,0x0,0x7,0x0,0x14
	.DB  0x7F,0x14,0x7F,0x14,0x24,0x2A,0x7F,0x2A
	.DB  0x12,0x23,0x13,0x8,0x64,0x62,0x36,0x49
	.DB  0x55,0x22,0x50,0x0,0x5,0x3,0x0,0x0
	.DB  0x0,0x1C,0x22,0x41,0x0,0x0,0x41,0x22
	.DB  0x1C,0x0,0x14,0x8,0x3E,0x8,0x14,0x8
	.DB  0x8,0x3E,0x8,0x8,0x0,0x50,0x30,0x0
	.DB  0x0,0x8,0x8,0x8,0x8,0x8,0x0,0x60
	.DB  0x60,0x0,0x0,0x20,0x10,0x8,0x4,0x2
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x5F
	.DB  0x0,0x0,0x0,0x7,0x0,0x7,0x0,0x14
	.DB  0x7F,0x14,0x7F,0x14,0x24,0x2A,0x7F,0x2A
	.DB  0x12,0x23,0x13,0x8,0x64,0x62,0x36,0x49
	.DB  0x55,0x22,0x50,0x0,0x5,0x3,0x0,0x0
	.DB  0x0,0x1C,0x22,0x41,0x0,0x0,0x41,0x22
	.DB  0x1C,0x0,0x14,0x8,0x3E,0x8,0x14,0x8
	.DB  0x8,0x3E,0x8,0x8,0x0,0x50,0x30,0x0
	.DB  0x0,0x8,0x8,0x8,0x8,0x8,0x0,0x60
	.DB  0x60,0x0,0x0,0x20,0x10,0x8,0x4,0x2
	.DB  0x0,0x6,0x9,0x9,0x6,0x0,0x42,0x7F
	.DB  0x40,0x0,0x42,0x61,0x51,0x49,0x46,0x21
	.DB  0x41,0x45,0x4B,0x31,0x18,0x14,0x12,0x7F
	.DB  0x10,0x27,0x45,0x45,0x45,0x39,0x3C,0x4A
	.DB  0x49,0x49,0x30,0x1,0x71,0x9,0x5,0x3
	.DB  0x36,0x49,0x49,0x49,0x36,0x6,0x49,0x49
	.DB  0x29,0x1E,0x0,0x36,0x36,0x0,0x0,0x0
	.DB  0x56,0x36,0x0,0x0,0x8,0x14,0x22,0x41
	.DB  0x0,0x14,0x14,0x14,0x14,0x14,0x0,0x41
	.DB  0x22,0x14,0x8,0x2,0x1,0x51,0x9,0x6
	.DB  0x7E,0x11,0x11,0x11,0x7E,0x7F,0x49,0x49
	.DB  0x49,0x31,0x7F,0x49,0x49,0x49,0x36,0x7F
	.DB  0x1,0x1,0x1,0x3,0x60,0x3E,0x21,0x21
	.DB  0x7F,0x7F,0x49,0x49,0x49,0x41,0x77,0x8
	.DB  0x7F,0x8,0x77,0x22,0x41,0x49,0x49,0x36
	.DB  0x7F,0x10,0x8,0x4,0x7F,0x7F,0x10,0x9
	.DB  0x4,0x7F,0x7F,0x8,0x14,0x22,0x41,0x40
	.DB  0x3E,0x1,0x1,0x7F,0x7F,0x2,0xC,0x2
	.DB  0x7F,0x7F,0x8,0x8,0x8,0x7F,0x3E,0x41
	.DB  0x41,0x41,0x3E,0x7F,0x1,0x1,0x1,0x7F
	.DB  0x7F,0x9,0x9,0x9,0x6,0x3E,0x41,0x41
	.DB  0x41,0x22,0x1,0x1,0x7F,0x1,0x1,0x27
	.DB  0x48,0x48,0x48,0x3F,0x1E,0x21,0x7F,0x21
	.DB  0x1E,0x63,0x14,0x8,0x14,0x63,0x3F,0x20
	.DB  0x20,0x3F,0x60,0x7,0x8,0x8,0x8,0x7F
	.DB  0x7F,0x40,0x7F,0x40,0x7F,0x3F,0x20,0x3F
	.DB  0x20,0x7F,0x1,0x7F,0x48,0x48,0x30,0x7F
	.DB  0x48,0x30,0x0,0x7F,0x0,0x7F,0x48,0x48
	.DB  0x30,0x22,0x41,0x49,0x49,0x3E,0x7F,0x8
	.DB  0x3E,0x41,0x3E,0x46,0x29,0x19,0x9,0x7F
	.DB  0x20,0x54,0x54,0x54,0x78,0x3C,0x4A,0x4A
	.DB  0x4A,0x30,0x7C,0x54,0x54,0x28,0x0,0x7C
	.DB  0x4,0x4,0x4,0x4,0x60,0x38,0x24,0x24
	.DB  0x7C,0x38,0x54,0x54,0x54,0x18,0x6C,0x10
	.DB  0x7C,0x10,0x6C,0x0,0x44,0x54,0x54,0x28
	.DB  0x7C,0x20,0x10,0x8,0x7C,0x7C,0x21,0x12
	.DB  0x9,0x7C,0x7C,0x10,0x28,0x44,0x0,0x40
	.DB  0x38,0x4,0x4,0x7C,0x7C,0x8,0x10,0x8
	.DB  0x7C,0x7C,0x10,0x10,0x10,0x7C,0x38,0x44
	.DB  0x44,0x44,0x38,0x7C,0x4,0x4,0x4,0x7C
	.DB  0x7C,0x14,0x14,0x14,0x8,0x38,0x44,0x44
	.DB  0x44,0x0,0x4,0x4,0x7C,0x4,0x4,0xC
	.DB  0x50,0x50,0x50,0x3C,0x8,0x14,0x7C,0x14
	.DB  0x8,0x44,0x28,0x10,0x28,0x44,0x3C,0x20
	.DB  0x20,0x3C,0x60,0xC,0x10,0x10,0x10,0x7C
	.DB  0x7C,0x40,0x7C,0x40,0x7C,0x3C,0x20,0x3C
	.DB  0x20,0x7C,0x4,0x7C,0x50,0x50,0x20,0x7C
	.DB  0x50,0x20,0x0,0x7C,0x0,0x7C,0x50,0x50
	.DB  0x20,0x28,0x44,0x54,0x54,0x38,0x7C,0x10
	.DB  0x38,0x44,0x38,0x48,0x54,0x34,0x14,0x7C
_BigNum:
	.DB  0x0,0x0,0x0,0xC0,0xE0,0xF0,0xF0,0xF0
	.DB  0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0
	.DB  0xF0,0xF0,0xF0,0xE0,0xC0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xFF,0xFF,0xFF,0xFF,0x1
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x1,0xFF,0xFF,0xFF,0xFF,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xFF,0xFF,0xFF,0xFF,0x80
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x80,0xFF,0xFF,0xFF,0xFF,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x3,0x7,0xF,0xF,0xF
	.DB  0xF,0xF,0xF,0xF,0xF,0xF,0xF,0xF
	.DB  0xF,0xF,0xF,0x7,0x3,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0xE0,0xF0
	.DB  0xF0,0xE0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0xFF,0xFF
	.DB  0xFF,0xFF,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0xFF,0xFF
	.DB  0xFF,0xFF,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x3,0x7
	.DB  0x7,0x3,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xE0,0xF0,0xF0,0xF0,0xF0
	.DB  0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0
	.DB  0xF0,0xF0,0xF0,0xE0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x81,0xC1,0xC0,0xC0,0xC0
	.DB  0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xE1
	.DB  0xFF,0xFF,0xFF,0xFF,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xFF,0xFF,0xFF,0xFF,0x87
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x3
	.DB  0x3,0x3,0x83,0x81,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x7,0xF,0xF,0xF,0xF
	.DB  0xF,0xF,0xF,0xF,0xF,0xF,0xF,0xF
	.DB  0xF,0xF,0xF,0x7,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xE0,0xF0,0xF0,0xF0,0xF0
	.DB  0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0
	.DB  0xF0,0xF0,0xF0,0xE0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x81,0xC1,0xC0,0xC0,0xC0
	.DB  0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xE1
	.DB  0xFF,0xFF,0xFF,0x7F,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x81,0x83,0x3,0x3,0x3
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x87
	.DB  0xFF,0xFF,0xFF,0xFE,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x7,0xF,0xF,0xF,0xF
	.DB  0xF,0xF,0xF,0xF,0xF,0xF,0xF,0xF
	.DB  0xF,0xF,0xF,0x7,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xE0,0xF0,0xF0,0xF0,0x30
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x30
	.DB  0xF0,0xF0,0xF0,0xE0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xFF,0xFF,0xFF,0xFF,0xE0
	.DB  0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xE0
	.DB  0xFF,0xFF,0xFF,0xFF,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x1,0x3,0x3,0x3,0x3
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x7
	.DB  0xFF,0xFF,0xFF,0xFF,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xC
	.DB  0xF,0xF,0xF,0x7,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xE0,0xF0,0xF0,0xF0,0xF0
	.DB  0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0
	.DB  0xF0,0xF0,0xF0,0xE0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xFF,0xFF,0xFF,0xFF,0xE1
	.DB  0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0
	.DB  0xC0,0xC0,0xC1,0x81,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x81,0x83,0x3,0x3,0x3
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x87
	.DB  0xFF,0xFF,0xFF,0xFF,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x7,0xF,0xF,0xF,0xF
	.DB  0xF,0xF,0xF,0xF,0xF,0xF,0xF,0xF
	.DB  0xF,0xF,0xF,0x7,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xE0,0xF0,0xF0,0xF0,0xF0
	.DB  0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0
	.DB  0xF0,0xF0,0xF0,0xE0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xFF,0xFF,0xFF,0xFF,0xE1
	.DB  0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0
	.DB  0xC0,0xC0,0xC1,0x81,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xFF,0xFF,0xFF,0xFF,0x87
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x87
	.DB  0xFF,0xFF,0xFF,0xFF,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x7,0xF,0xF,0xF,0xF
	.DB  0xF,0xF,0xF,0xF,0xF,0xF,0xF,0xF
	.DB  0xF,0xF,0xF,0x7,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xE0,0xF0,0xF0,0xF0,0xF0
	.DB  0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0
	.DB  0xF0,0xF0,0xF0,0xE0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x1,0x1,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1
	.DB  0xFF,0xFF,0xFF,0xFF,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0xFF,0xFF,0xFF,0xFF,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xC
	.DB  0xF,0xF,0xF,0x7,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xE0,0xF0,0xF0,0xF0,0xF0
	.DB  0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0
	.DB  0xF0,0xF0,0xF0,0xE0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x7F,0xFF,0xFF,0xFF,0xE1
	.DB  0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xE1
	.DB  0xFF,0xFF,0xFF,0x3F,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xFE,0xFF,0xFF,0xFF,0x87
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x87
	.DB  0xFF,0xFF,0xFF,0xFE,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x7,0xF,0xF,0xF,0xF
	.DB  0xF,0xF,0xF,0xF,0xF,0xF,0xF,0xF
	.DB  0xF,0xF,0xF,0x7,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xE0,0xF0,0xF0,0xF0,0xF0
	.DB  0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0
	.DB  0xF0,0xF0,0xF0,0xE0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xFF,0xFF,0xFF,0xFF,0xE1
	.DB  0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xE1
	.DB  0xFF,0xFF,0xFF,0xFF,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x1,0x3,0x3,0x3,0x3
	.DB  0x3,0x3,0x3,0x3,0x3,0x3,0x3,0x7
	.DB  0xFF,0xFF,0xFF,0xFF,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xC
	.DB  0xF,0xF,0xF,0x7,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x3C,0x7E,0x7E,0x7E,0x7E,0x3C,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xF0,0xF8,0xF8,0xF8,0xF8,0xF0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x1,0x1,0x1,0x1,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xF,0xF,0xF,0xF,0xF,0xF,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x1F,0x11,0x11,0x11,0x1F,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0

_0x4B:
	.DB  0x0,0x0
_0x0:
	.DB  0x58,0x3D,0x25,0x69,0x20,0x0,0xDF,0x20
	.DB  0xE4,0xE8,0xF1,0xEF,0xEB,0xE5,0xE9,0x20
	.DB  0x53,0x53,0x44,0x31,0x33,0x30,0x36,0x0
	.DB  0x25,0x2E,0x31,0x66,0x3A,0x43,0x0,0x31
	.DB  0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39
	.DB  0x31,0x30,0x0,0xD1,0xF2,0xF0,0xEE,0xEA
	.DB  0xE0,0x20,0x38,0x0
_0x2000000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0
_0x2080060:
	.DB  0x1
_0x2080000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0

__GLOBAL_INI_TBL:
	.DW  0x02
	.DW  0x05
	.DW  _0x4B*2

	.DW  0x01
	.DW  __seed_G104
	.DW  _0x2080060*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,LOW(__SRAM_START)
	LDI  R27,HIGH(__SRAM_START)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x300

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.05.0 Professional
;Automatic Program Generator
; Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 21.12.2015
;Author  : NeVaDa
;Company :
;Comments:
;
;
;Chip type               : ATmega328P
;Program type            : Application
;AVR Core Clock frequency: 8,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 512
;*****************************************************/
;
;#include <mega328p.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.SET power_ctrl_reg=smcr
	#endif
;
;// I2C Bus functions
;#asm
   .equ __i2c_port=0x0B ;PORTD
   .equ __sda_bit=5
   .equ __scl_bit=6
; 0000 001F #endasm
;#include <i2c.h>
;#include <stdio.h>
;#include "ssd1306.c"
;/*
;  
;OLED LCD SSD1306 .
;   CVAVR.
;22.12.2015  ..
;*/
;
;#include <delay.h>
;
;void LCD_init(void);  //  
;void LCD_Commmand(unsigned char ControByte, unsigned char DataByte); //   
;void LCD_Goto(unsigned char x, unsigned char y);    // 
;void LCD_Goto2X(unsigned char x, unsigned char y); //    2
;void LCD_Clear(void);  //  
;void LCD_Contrast(char set_contrast); //   0  255
;void LCD_BigNum(unsigned char num);  //  
;void LCD_Char(unsigned int c);  // 
;void LCD_CharBig(unsigned int c); //   
;void LCD_Printf(unsigned char* buf, unsigned char size); //    - 0   2 -  - 3  (  )
;void LCD_DrawImage(unsigned char num_image); //   
;void LCD_Bat(unsigned char y,unsigned char x, unsigned char z);   //    z -  0  10 
;void LCD_Mode(char set_mode); //1 - inverted / 0 - normal
;void LCD_Sleep(char set);   //1 - on sleep / 0 - off sleep
;
;unsigned char LCD_X,LCD_Y;
;
;#define SSD1306_I2C_ADDRESS					 0x78
;// size
;#define SSD1306_LCDWIDTH                      128
;#define SSD1306_LCDHEIGHT                     64
;#define SSD1306_DEFAULT_SPACE                 5
;// Commands
;#define SSD1306_SETCONTRAST                  0x81
;#define SSD1306_DISPLAYALLON_RESUME          0xA4
;#define SSD1306_DISPLAYALLON                 0xA5
;#define SSD1306_NORMALDISPLAY                0xA6
;#define SSD1306_INVERTDISPLAY                0xA7
;#define SSD1306_DISPLAYOFF                   0xAE
;#define SSD1306_DISPLAYON                    0xAF
;#define SSD1306_SETDISPLAYOFFSET             0xD3
;#define SSD1306_SETCOMPINS                   0xDA
;#define SSD1306_SETVCOMDETECT                0xDB
;#define SSD1306_SETDISPLAYCLOCKDIV           0xD5
;#define SSD1306_SETPRECHARGE                 0xD9
;#define SSD1306_SETMULTIPLEX                 0xA8
;#define SSD1306_SETLOWCOLUMN                 0x00
;#define SSD1306_SETHIGHCOLUMN                0x10
;#define SSD1306_SETSTARTLINE                 0x40
;#define SSD1306_MEMORYMODE                   0x20
;#define SSD1306_COLUMNADDR                   0x21
;#define SSD1306_PAGEADDR                     0x22
;#define SSD1306_COMSCANINC                   0xC0
;#define SSD1306_COMSCANDEC                   0xC8
;#define SSD1306_SEGREMAP                     0xA0
;#define SSD1306_CHARGEPUMP                   0x8D
;#define SSD1306_EXTERNALVCC                   0x1
;#define SSD1306_SWITCHCAPVCC                  0x2
;// Scrolling #defines
;#define SSD1306_ACTIVATE_SCROLL               0x2F
;#define SSD1306_DEACTIVATE_SCROLL             0x2E
;#define SSD1306_SET_VERTICAL_SCROLL_AREA      0xA3
;#define SSD1306_RIGHT_HORIZONTAL_SCROLL       0x26
;#define SSD1306_LEFT_HORIZONTAL_SCROLL        0x27
;#define SSD1306_VERT_AND_RIGHT_HORIZ_SCROLL   0x29
;#define SSD1306_VERT_AND_LEFT_HORIZ_SCROLL    0x2A
;
;#define COMAND		                          0x00
;#define DATA		                          0x40
;
;flash unsigned char image0[1026] =
;{
;0x00,0xFE,0x02,0x02,0x02,0x02,0x02,0x02,
;0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
;0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
;0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
;0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
;0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
;0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
;0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
;0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
;0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
;0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
;0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
;0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
;0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
;0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
;0x02,0x02,0x02,0x02,0x02,0x02,0xFE,0x00,
;0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0xFF,
;0xFF,0x07,0x1E,0x38,0x60,0xC0,0x60,0x30,
;0x1E,0x07,0xFF,0xFF,0x00,0x00,0xFF,0xFF,
;0x83,0x83,0x83,0x83,0x83,0x83,0x83,0x00,
;0x00,0xFC,0xFC,0x06,0x03,0x03,0x83,0x83,
;0x83,0x8F,0x8E,0x00,0x00,0xF0,0xF8,0x8C,
;0x84,0x86,0x83,0x83,0x83,0x86,0x8C,0x8C,
;0xF8,0xF0,0x00,0x00,0x80,0x80,0x80,0x80,
;0x80,0x80,0x00,0x00,0xF0,0xF8,0x9C,0x8C,
;0x86,0x87,0x83,0x83,0x87,0x8E,0x9C,0xF8,
;0xF0,0x00,0x00,0xFF,0xFF,0x00,0x00,0x00,
;0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,
;0x00,0x00,0xFC,0xFE,0x83,0x83,0x83,0x83,
;0x83,0x83,0x83,0xFE,0x3C,0x00,0x00,0x00,
;0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,
;0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0xFF,
;0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0xFF,0xFF,0x00,0x00,0xFF,0xFF,
;0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0x00,
;0x00,0x1F,0x3F,0x70,0xE0,0xC0,0xC1,0xE1,
;0x31,0x3F,0x0F,0x00,0x00,0xFF,0xFF,0x01,
;0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
;0xFF,0xFF,0x00,0x00,0x01,0x01,0x01,0x01,
;0x01,0x01,0x00,0x00,0xFF,0xFF,0x01,0x01,
;0x01,0x01,0x01,0x01,0x01,0x01,0x01,0xFF,
;0xFF,0x00,0x00,0x03,0x0F,0x18,0x30,0x60,
;0xC0,0x80,0x80,0xC0,0x70,0x18,0x0F,0x03,
;0x00,0x00,0xFF,0xFF,0x01,0x01,0x03,0x07,
;0x0D,0x39,0x71,0xC0,0x80,0x00,0x00,0x00,
;0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,
;0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x80,0x80,0xC0,0xC0,0xC0,0xC0,0xC0,
;0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,
;0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x20,0x60,0xC0,0xC0,0x80,0x80,0x00,
;0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,
;0xC0,0xC0,0x20,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,
;0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0x00,0x80,0xE0,0xF8,0x3C,0x1E,
;0x06,0x03,0xC1,0x61,0x20,0x20,0x60,0xC0,
;0x00,0x00,0x00,0x80,0xC0,0x41,0x41,0xC1,
;0x03,0x03,0x03,0x06,0x1C,0x18,0x38,0x70,
;0xE0,0x80,0x00,0x00,0x00,0x00,0x00,0x01,
;0x03,0x06,0x0C,0x18,0x30,0xE0,0xC0,0xC0,
;0xC0,0xE0,0x30,0x18,0x0C,0x06,0x03,0x01,
;0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0x00,0x00,0x00,0x01,0x03,0x07,
;0x0F,0x0E,0x1C,0x3C,0x78,0x78,0xF0,0xF0,
;0xE0,0xC0,0xC0,0x80,0x80,0x00,0x00,0x00,
;0x00,0x00,0x80,0x80,0xC0,0xE0,0xE0,0xF0,
;0xF8,0xF8,0xFC,0xFC,0x7E,0x1F,0x0F,0x03,
;0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,
;0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0xF8,0xFF,0x03,0x00,0x00,0x00,
;0x80,0x87,0x8D,0x0C,0x09,0x0C,0x06,0x03,
;0x00,0x00,0x1F,0x11,0x12,0x18,0x0C,0x87,
;0x80,0x00,0x00,0x00,0x00,0x00,0x00,0xE0,
;0x7F,0x0F,0x00,0x00,0x00,0x00,0x00,0x00,
;0xFF,0xFF,0x03,0x03,0x03,0x03,0x03,0x03,
;0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,
;0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x81,
;0xC3,0xE7,0xE7,0xFF,0xFF,0xFF,0xFF,0xFE,
;0xFE,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
;0xCF,0x87,0x83,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,
;0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0x0F,0x1F,0x7C,0xF8,0xC0,0x80,
;0x81,0x87,0x8D,0x8B,0x0A,0x1A,0x16,0x14,
;0x14,0x14,0x14,0x14,0x16,0x1B,0x0D,0x07,
;0x81,0x80,0xC0,0xE0,0x78,0x3E,0x1F,0x07,
;0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
;0xFF,0xFF,0x80,0x80,0x80,0x80,0x80,0x80,
;0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,
;0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,
;0x00,0x00,0x80,0xC0,0xC0,0xE0,0xF0,0xF0,
;0xF8,0xFC,0xFC,0xFE,0xFF,0xFF,0xFF,0xFF,
;0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
;0xFF,0xBF,0x9F,0x8F,0x87,0x8F,0x9F,0xBF,
;0xBF,0xFF,0xFF,0xFF,0xFF,0xFE,0xFE,0xFC,
;0xFC,0xF8,0xF0,0xF0,0xE0,0xE0,0xC0,0xC0,
;0x80,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,
;0x00,0x7F,0x40,0x40,0x40,0x40,0x40,0x40,
;0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x41,
;0x43,0x43,0x43,0x43,0x43,0x43,0x43,0x43,
;0x43,0x43,0x43,0x43,0x43,0x43,0x43,0x43,
;0x41,0x41,0x41,0x40,0x40,0x40,0x40,0x40,
;0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
;0x41,0x41,0x41,0x41,0x41,0x41,0x41,0x41,
;0x41,0x41,0x41,0x41,0x41,0x41,0x41,0x41,
;0x41,0x41,0x40,0x40,0x40,0x40,0x40,0x40,
;0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
;0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
;0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
;0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
;0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
;0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x40,
;0x40,0x40,0x40,0x40,0x40,0x40,0x7F,0x00
;};
;
;flash unsigned char LCD_Buffer[0x0500] =
;{
;0x00, 0x00, 0x00, 0x00, 0x00,// 00
;0x00, 0x00, 0x5F, 0x00, 0x00,// 01
;0x00, 0x07, 0x00, 0x07, 0x00,// 02
;0x14, 0x7F, 0x14, 0x7F, 0x14,// 03
;0x24, 0x2A, 0x7F, 0x2A, 0x12,// 04
;0x23, 0x13, 0x08, 0x64, 0x62,// 05
;0x36, 0x49, 0x55, 0x22, 0x50,// 06
;0x00, 0x05, 0x03, 0x00, 0x00,// 07
;0x00, 0x1C, 0x22, 0x41, 0x00,// 08
;0x00, 0x41, 0x22, 0x1C, 0x00,// 09
;0x14, 0x08, 0x3E, 0x08, 0x14,// 0A
;0x08, 0x08, 0x3E, 0x08, 0x08,// 0B
;0x00, 0x50, 0x30, 0x00, 0x00,// 0C
;0x08, 0x08, 0x08, 0x08, 0x08,// 0D
;0x00, 0x60, 0x60, 0x00, 0x00,// 0E
;0x20, 0x10, 0x08, 0x04, 0x02,// 0F
;0x00, 0x00, 0x00, 0x00, 0x00,// 10
;0x00, 0x00, 0x5F, 0x00, 0x00,// 11
;0x00, 0x07, 0x00, 0x07, 0x00,// 12
;0x14, 0x7F, 0x14, 0x7F, 0x14,// 13
;0x24, 0x2A, 0x7F, 0x2A, 0x12,// 14
;0x23, 0x13, 0x08, 0x64, 0x62,// 15
;0x36, 0x49, 0x55, 0x22, 0x50,// 16
;0x00, 0x05, 0x03, 0x00, 0x00,// 17
;0x00, 0x1C, 0x22, 0x41, 0x00,// 18
;0x00, 0x41, 0x22, 0x1C, 0x00,// 19
;0x14, 0x08, 0x3E, 0x08, 0x14,// 1A
;0x08, 0x08, 0x3E, 0x08, 0x08,// 1B
;0x00, 0x50, 0x30, 0x00, 0x00,// 1C
;0x08, 0x08, 0x08, 0x08, 0x08,// 1D
;0x00, 0x60, 0x60, 0x00, 0x00,// 1E
;0x20, 0x10, 0x08, 0x04, 0x02,// 1F
;0x00, 0x00, 0x00, 0x00, 0x00,// 20 space
;0x00, 0x00, 0x5F, 0x00, 0x00,// 21 !
;0x00, 0x07, 0x00, 0x07, 0x00,// 22 "
;0x14, 0x7F, 0x14, 0x7F, 0x14,// 23 #
;0x24, 0x2A, 0x7F, 0x2A, 0x12,// 24 $
;0x23, 0x13, 0x08, 0x64, 0x62,// 25 %
;0x36, 0x49, 0x55, 0x22, 0x50,// 26 &
;0x00, 0x05, 0x03, 0x00, 0x00,// 27 '
;0x00, 0x1C, 0x22, 0x41, 0x00,// 28 (
;0x00, 0x41, 0x22, 0x1C, 0x00,// 29 )
;0x14, 0x08, 0x3E, 0x08, 0x14,// 2a *
;0x08, 0x08, 0x3E, 0x08, 0x08,// 2b +
;0x00, 0x50, 0x30, 0x00, 0x00,// 2c ,
;0x08, 0x08, 0x08, 0x08, 0x08,// 2d -
;0x00, 0x60, 0x60, 0x00, 0x00,// 2e .
;0x20, 0x10, 0x08, 0x04, 0x02,// 2f /
;0x3E, 0x51, 0x49, 0x45, 0x3E,// 30 0
;0x00, 0x42, 0x7F, 0x40, 0x00,// 31 1
;0x42, 0x61, 0x51, 0x49, 0x46,// 32 2
;0x21, 0x41, 0x45, 0x4B, 0x31,// 33 3
;0x18, 0x14, 0x12, 0x7F, 0x10,// 34 4
;0x27, 0x45, 0x45, 0x45, 0x39,// 35 5
;0x3C, 0x4A, 0x49, 0x49, 0x30,// 36 6
;0x01, 0x71, 0x09, 0x05, 0x03,// 37 7
;0x36, 0x49, 0x49, 0x49, 0x36,// 38 8
;0x06, 0x49, 0x49, 0x29, 0x1E,// 39 9
;0x00, 0x36, 0x36, 0x00, 0x00,// 3a :
;0x00, 0x56, 0x36, 0x00, 0x00,// 3b ;
;0x08, 0x14, 0x22, 0x41, 0x00,// 3c <
;0x14, 0x14, 0x14, 0x14, 0x14,// 3d =
;0x00, 0x41, 0x22, 0x14, 0x08,// 3e >
;0x02, 0x01, 0x51, 0x09, 0x06,// 3f ?
;0x32, 0x49, 0x79, 0x41, 0x3E,// 40 @
;0x7E, 0x11, 0x11, 0x11, 0x7E,// 41 A
;0x7F, 0x49, 0x49, 0x49, 0x36,// 42 B
;0x3E, 0x41, 0x41, 0x41, 0x22,// 43 C
;0x7F, 0x41, 0x41, 0x22, 0x1C,// 44 D
;0x7F, 0x49, 0x49, 0x49, 0x41,// 45 E
;0x7F, 0x09, 0x09, 0x09, 0x01,// 46 F
;0x3E, 0x41, 0x49, 0x49, 0x7A,// 47 G
;0x7F, 0x08, 0x08, 0x08, 0x7F,// 48 H
;0x00, 0x41, 0x7F, 0x41, 0x00,// 49 I
;0x20, 0x40, 0x41, 0x3F, 0x01,// 4a J
;0x7F, 0x08, 0x14, 0x22, 0x41,// 4b K
;0x7F, 0x40, 0x40, 0x40, 0x40,// 4c L
;0x7F, 0x02, 0x0C, 0x02, 0x7F,// 4d M
;0x7F, 0x04, 0x08, 0x10, 0x7F,// 4e N
;0x3E, 0x41, 0x41, 0x41, 0x3E,// 4f O
;0x7F, 0x09, 0x09, 0x09, 0x06,// 50 P
;0x3E, 0x41, 0x51, 0x21, 0x5E,// 51 Q
;0x7F, 0x09, 0x19, 0x29, 0x46,// 52 R
;0x46, 0x49, 0x49, 0x49, 0x31,// 53 S
;0x01, 0x01, 0x7F, 0x01, 0x01,// 54 T
;0x3F, 0x40, 0x40, 0x40, 0x3F,// 55 U
;0x1F, 0x20, 0x40, 0x20, 0x1F,// 56 V
;0x3F, 0x40, 0x38, 0x40, 0x3F,// 57 W
;0x63, 0x14, 0x08, 0x14, 0x63,// 58 X
;0x07, 0x08, 0x70, 0x08, 0x07,// 59 Y
;0x61, 0x51, 0x49, 0x45, 0x43,// 5a Z
;0x00, 0x7F, 0x41, 0x41, 0x00,// 5b [
;0x02, 0x04, 0x08, 0x10, 0x20,// 5c Yen Currency Sign
;0x00, 0x41, 0x41, 0x7F, 0x00,// 5d ]
;0x04, 0x02, 0x01, 0x02, 0x04,// 5e ^
;0x40, 0x40, 0x40, 0x40, 0x40,// 5f _
;0x00, 0x01, 0x02, 0x04, 0x00,// 60 `
;0x20, 0x54, 0x54, 0x54, 0x78,// 61 a
;0x7F, 0x48, 0x44, 0x44, 0x38,// 62 b
;0x38, 0x44, 0x44, 0x44, 0x20,// 63 c
;0x38, 0x44, 0x44, 0x48, 0x7F,// 64 d
;0x38, 0x54, 0x54, 0x54, 0x18,// 65 e
;0x08, 0x7E, 0x09, 0x01, 0x02,// 66 f
;0x0C, 0x52, 0x52, 0x52, 0x3E,// 67 g
;0x7F, 0x08, 0x04, 0x04, 0x78,// 68 h
;0x00, 0x44, 0x7D, 0x40, 0x00,// 69 i
;0x20, 0x40, 0x44, 0x3D, 0x00,// 6a j
;0x7F, 0x10, 0x28, 0x44, 0x00,// 6b k
;0x00, 0x41, 0x7F, 0x40, 0x00,// 6c l
;0x7C, 0x04, 0x18, 0x04, 0x78,// 6d m
;0x7C, 0x08, 0x04, 0x04, 0x78,// 6e n
;0x38, 0x44, 0x44, 0x44, 0x38,// 6f o
;0x7C, 0x14, 0x14, 0x14, 0x08,// 70 p
;0x08, 0x14, 0x14, 0x18, 0x7C,// 71 q
;0x7C, 0x08, 0x04, 0x04, 0x08,// 72 r
;0x08, 0x54, 0x54, 0x54, 0x20,// 73 s
;0x04, 0x3F, 0x44, 0x40, 0x20,// 74 t
;0x3C, 0x40, 0x40, 0x20, 0x7C,// 75 u
;0x1C, 0x20, 0x40, 0x20, 0x1C,// 76 v
;0x3C, 0x40, 0x30, 0x40, 0x3C,// 77 w
;0x44, 0x28, 0x10, 0x28, 0x44,// 78 x
;0x0C, 0x50, 0x50, 0x50, 0x3C,// 79 y
;0x44, 0x64, 0x54, 0x4C, 0x44,// 7a z
;0x00, 0x08, 0x36, 0x41, 0x00,// 7b <
;0x00, 0x00, 0x7F, 0x00, 0x00,// 7c |
;0x00, 0x41, 0x36, 0x08, 0x00,// 7d >
;0x10, 0x08, 0x08, 0x10, 0x08,// 7e Right Arrow ->
;0x78, 0x46, 0x41, 0x46, 0x78,// 7f Left Arrow <-
;0x00, 0x00, 0x00, 0x00, 0x00,// 80
;0x00, 0x00, 0x5F, 0x00, 0x00,// 81
;0x00, 0x07, 0x00, 0x07, 0x00,// 82
;0x14, 0x7F, 0x14, 0x7F, 0x14,// 83
;0x24, 0x2A, 0x7F, 0x2A, 0x12,// 84
;0x23, 0x13, 0x08, 0x64, 0x62,// 85
;0x36, 0x49, 0x55, 0x22, 0x50,// 86
;0x00, 0x05, 0x03, 0x00, 0x00,// 87
;0x00, 0x1C, 0x22, 0x41, 0x00,// 88
;0x00, 0x41, 0x22, 0x1C, 0x00,// 89
;0x14, 0x08, 0x3E, 0x08, 0x14,// 8A
;0x08, 0x08, 0x3E, 0x08, 0x08,// 8B
;0x00, 0x50, 0x30, 0x00, 0x00,// 8C
;0x08, 0x08, 0x08, 0x08, 0x08,// 8D
;0x00, 0x60, 0x60, 0x00, 0x00,// 8E
;0x20, 0x10, 0x08, 0x04, 0x02,// 8F
;0x00, 0x00, 0x00, 0x00, 0x00,// 90
;0x00, 0x00, 0x5F, 0x00, 0x00,// 91
;0x00, 0x07, 0x00, 0x07, 0x00,// 92
;0x14, 0x7F, 0x14, 0x7F, 0x14,// 93
;0x24, 0x2A, 0x7F, 0x2A, 0x12,// 94
;0x23, 0x13, 0x08, 0x64, 0x62,// 95
;0x36, 0x49, 0x55, 0x22, 0x50,// 96
;0x00, 0x05, 0x03, 0x00, 0x00,// 97
;0x00, 0x1C, 0x22, 0x41, 0x00,// 98
;0x00, 0x41, 0x22, 0x1C, 0x00,// 99
;0x14, 0x08, 0x3E, 0x08, 0x14,// 9A
;0x08, 0x08, 0x3E, 0x08, 0x08,// 9B
;0x00, 0x50, 0x30, 0x00, 0x00,// 9C
;0x08, 0x08, 0x08, 0x08, 0x08,// 9D
;0x00, 0x60, 0x60, 0x00, 0x00,// 9E
;0x20, 0x10, 0x08, 0x04, 0x02,// 9F
;0x00, 0x00, 0x00, 0x00, 0x00,// A0
;0x00, 0x00, 0x5F, 0x00, 0x00,// A1
;0x00, 0x07, 0x00, 0x07, 0x00,// A2
;0x14, 0x7F, 0x14, 0x7F, 0x14,// A3
;0x24, 0x2A, 0x7F, 0x2A, 0x12,// A4
;0x23, 0x13, 0x08, 0x64, 0x62,// A5
;0x36, 0x49, 0x55, 0x22, 0x50,// A6
;0x00, 0x05, 0x03, 0x00, 0x00,// A7
;0x00, 0x1C, 0x22, 0x41, 0x00,// A8
;0x00, 0x41, 0x22, 0x1C, 0x00,// A9
;0x14, 0x08, 0x3E, 0x08, 0x14,// AA
;0x08, 0x08, 0x3E, 0x08, 0x08,// AB
;0x00, 0x50, 0x30, 0x00, 0x00,// AC
;0x08, 0x08, 0x08, 0x08, 0x08,// AD
;0x00, 0x60, 0x60, 0x00, 0x00,// AE
;0x20, 0x10, 0x08, 0x04, 0x02,// AF
;//0x3E, 0x51, 0x49, 0x45, 0x3E,// B0
;0x00, 0x06, 0x09, 0x09, 0x06,
;0x00, 0x42, 0x7F, 0x40, 0x00,// B1
;0x42, 0x61, 0x51, 0x49, 0x46,// B2
;0x21, 0x41, 0x45, 0x4B, 0x31,// B3
;0x18, 0x14, 0x12, 0x7F, 0x10,// B4
;0x27, 0x45, 0x45, 0x45, 0x39,// B5
;0x3C, 0x4A, 0x49, 0x49, 0x30,// B6
;0x01, 0x71, 0x09, 0x05, 0x03,// B7
;0x36, 0x49, 0x49, 0x49, 0x36,// B8
;0x06, 0x49, 0x49, 0x29, 0x1E,// B9
;0x00, 0x36, 0x36, 0x00, 0x00,// BA
;0x00, 0x56, 0x36, 0x00, 0x00,// BB
;0x08, 0x14, 0x22, 0x41, 0x00,// BC
;0x14, 0x14, 0x14, 0x14, 0x14,// BD
;0x00, 0x41, 0x22, 0x14, 0x08,// BE
;0x02, 0x01, 0x51, 0x09, 0x06,// BF
;0x7E, 0x11, 0x11, 0x11, 0x7E,// C0 
;0x7F, 0x49, 0x49, 0x49, 0x31,// C1 
;0x7F, 0x49, 0x49, 0x49, 0x36,// C2 
;0x7F, 0x01, 0x01, 0x01, 0x03,// C3 
;0x60, 0x3E, 0x21, 0x21, 0x7F,// C4 
;0x7F, 0x49, 0x49, 0x49, 0x41,// C5 
;0x77, 0x08, 0x7F, 0x08, 0x77,// C6 
;0x22, 0x41, 0x49, 0x49, 0x36,// C7 
;0x7F, 0x10, 0x08, 0x04, 0x7F,// C8 
;0x7F, 0x10, 0x09, 0x04, 0x7F,// C9 
;0x7F, 0x08, 0x14, 0x22, 0x41,// CA 
;0x40, 0x3E, 0x01, 0x01, 0x7F,// CB 
;0x7F, 0x02, 0x0C, 0x02, 0x7F,// CC 
;0x7F, 0x08, 0x08, 0x08, 0x7F,// CD 
;0x3E, 0x41, 0x41, 0x41, 0x3E,// CE 
;0x7F, 0x01, 0x01, 0x01, 0x7F,// CF 
;0x7F, 0x09, 0x09, 0x09, 0x06,// D0 
;0x3E, 0x41, 0x41, 0x41, 0x22,// D1 
;0x01, 0x01, 0x7F, 0x01, 0x01,// D2 
;0x27, 0x48, 0x48, 0x48, 0x3F,// D3 
;0x1E, 0x21, 0x7F, 0x21, 0x1E,// D4 
;0x63, 0x14, 0x08, 0x14, 0x63,// D5 
;0x3F, 0x20, 0x20, 0x3F, 0x60,// D6 
;0x07, 0x08, 0x08, 0x08, 0x7F,// D7 
;0x7F, 0x40, 0x7F, 0x40, 0x7F,// D8 
;0x3F, 0x20, 0x3F, 0x20, 0x7F,// D9 
;0x01, 0x7F, 0x48, 0x48, 0x30,// DA 
;0x7F, 0x48, 0x30, 0x00, 0x7F,// DB 
;0x00, 0x7F, 0x48, 0x48, 0x30,// DC 
;0x22, 0x41, 0x49, 0x49, 0x3E,// DD 
;0x7F, 0x08, 0x3E, 0x41, 0x3E,// DE 
;0x46, 0x29, 0x19, 0x09, 0x7F,// DF 
;0x20, 0x54, 0x54, 0x54, 0x78,// E0 
;0x3C, 0x4A, 0x4A, 0x4A, 0x30,// E1 
;0x7C, 0x54, 0x54, 0x28, 0x00,// E2 
;0x7C, 0x04, 0x04, 0x04, 0x04,// E3 
;0x60, 0x38, 0x24, 0x24, 0x7C,// E4 
;0x38, 0x54, 0x54, 0x54, 0x18,// E5 
;0x6C, 0x10, 0x7C, 0x10, 0x6C,// E6 
;0x00, 0x44, 0x54, 0x54, 0x28,// E7 
;0x7C, 0x20, 0x10, 0x08, 0x7C,// E8 
;0x7C, 0x21, 0x12, 0x09, 0x7C,// E9 
;0x7C, 0x10, 0x28, 0x44, 0x00,// EA 
;0x40, 0x38, 0x04, 0x04, 0x7C,// EB 
;0x7C, 0x08, 0x10, 0x08, 0x7C,// EC 
;0x7C, 0x10, 0x10, 0x10, 0x7C,// ED 
;0x38, 0x44, 0x44, 0x44, 0x38,// EE 
;0x7C, 0x04, 0x04, 0x04, 0x7C,// EF 
;0x7C, 0x14, 0x14, 0x14, 0x08,// F0 
;0x38, 0x44, 0x44, 0x44, 0x00,// F1 
;0x04, 0x04, 0x7C, 0x04, 0x04,// F2 
;0x0C, 0x50, 0x50, 0x50, 0x3C,// F3 
;0x08, 0x14, 0x7C, 0x14, 0x08,// F4 
;0x44, 0x28, 0x10, 0x28, 0x44,// F5 
;0x3C, 0x20, 0x20, 0x3C, 0x60,// F6 
;0x0C, 0x10, 0x10, 0x10, 0x7C,// F7 
;0x7C, 0x40, 0x7C, 0x40, 0x7C,// F8 
;0x3C, 0x20, 0x3C, 0x20, 0x7C,// F9 
;0x04, 0x7C, 0x50, 0x50, 0x20,// FA 
;0x7C, 0x50, 0x20, 0x00, 0x7C,// FB 
;0x00, 0x7C, 0x50, 0x50, 0x20,// FC 
;0x28, 0x44, 0x54, 0x54, 0x38,// FD 
;0x7C, 0x10, 0x38, 0x44, 0x38,// FE 
;0x48, 0x54, 0x34, 0x14, 0x7C // FF 
;};
;
;flash unsigned char BigNum[15][96] =
;{ //0
;{0x00, 0x00, 0x00, 0xC0, 0xE0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0,
;0xF0, 0xF0, 0xF0, 0xE0, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0x01,
;0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00,
;0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
;0x80, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x07, 0x0F, 0x0F, 0x0F,
;0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x07, 0x03, 0x00, 0x00, 0x00},
; //1
;{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0xF0,
;0xF0, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
;0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
;0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF,
;0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
;0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x07, 0x07, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
; //2
;{0x00, 0x00, 0x00, 0xE0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0,
;0xF0, 0xF0, 0xF0, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x81, 0xC1, 0xC0, 0xC0, 0xC0,
;0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE1, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00,
;0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0x87, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
;0x03, 0x03, 0x83, 0x81, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x0F, 0x0F, 0x0F, 0x0F,
;0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x07, 0x00, 0x00, 0x00, 0x00},
;   //3
;{0x00, 0x00, 0x00, 0xE0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0,
;0xF0, 0xF0, 0xF0, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x81, 0xC1, 0xC0, 0xC0, 0xC0,
;0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE1, 0xFF, 0xFF, 0xFF, 0x7F, 0x00, 0x00, 0x00, 0x00,
;0x00, 0x00, 0x00, 0x81, 0x83, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x87,
;0xFF, 0xFF, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x0F, 0x0F, 0x0F, 0x0F,
;0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x07, 0x00, 0x00, 0x00, 0x00},
;  //4
;{0x00, 0x00, 0x00, 0xE0, 0xF0, 0xF0, 0xF0, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30,
;0xF0, 0xF0, 0xF0, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xE0,
;0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE0, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00,
;0x00, 0x00, 0x00, 0x01, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x07,
;0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
;0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0C, 0x0F, 0x0F, 0x0F, 0x07, 0x00, 0x00, 0x00, 0x00},
;  //5
;{0x00, 0x00, 0x00, 0xE0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0,
;0xF0, 0xF0, 0xF0, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xE1,
;0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC1, 0x81, 0x00, 0x00, 0x00, 0x00,
;0x00, 0x00, 0x00, 0x81, 0x83, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x87,
;0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x0F, 0x0F, 0x0F, 0x0F,
;0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x07, 0x00, 0x00, 0x00, 0x00},
; //6
;{0x00, 0x00, 0x00, 0xE0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0,
;0xF0, 0xF0, 0xF0, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xE1,
;0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC1, 0x81, 0x00, 0x00, 0x00, 0x00,
;0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0x87, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x87,
;0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x0F, 0x0F, 0x0F, 0x0F,
;0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x07, 0x00, 0x00, 0x00, 0x00},
;  //7
;{0x00, 0x00, 0x00, 0xE0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0,
;0xF0, 0xF0, 0xF0, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x00, 0x00, 0x00,
;0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00,
;0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
;0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
;0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0C, 0x0F, 0x0F, 0x0F, 0x07, 0x00, 0x00, 0x00, 0x00},
;  //8
;{0x00, 0x00, 0x00, 0xE0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0,
;0xF0, 0xF0, 0xF0, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xE1,
;0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE1, 0xFF, 0xFF, 0xFF, 0x3F, 0x00, 0x00, 0x00, 0x00,
;0x00, 0x00, 0x00, 0xFE, 0xFF, 0xFF, 0xFF, 0x87, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x87,
;0xFF, 0xFF, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x0F, 0x0F, 0x0F, 0x0F,
;0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x07, 0x00, 0x00, 0x00, 0x00},
;    //9
;{0x00, 0x00, 0x00, 0xE0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0,
;0xF0, 0xF0, 0xF0, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xE1,
;0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xC0, 0xE1, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00,
;0x00, 0x00, 0x00, 0x01, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x07,
;0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
;0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0C, 0x0F, 0x0F, 0x0F, 0x07, 0x00, 0x00, 0x00, 0x00},
;  //:    10
;{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
; 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3C, 0x7E, 0x7E, 0x7E, 0x7E, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
; 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF0, 0xF8, 0xF8, 0xF8, 0xF8, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
; 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
;  // .   11
;{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
; 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
; 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
; 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
; //space   12
;{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
; 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
; 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
; 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
; //    13
;{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0x11, 0x11, 0x11, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
; 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
; 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
; 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}
;
;};
;
;void LCD_init(void)
; 0000 0022 {

	.CSEG
_LCD_init:
;  LCD_Sleep(0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _LCD_Sleep
;  delay_ms(10);
	CALL SUBOPT_0x0
;  LCD_Commmand(COMAND, SSD1306_SETDISPLAYCLOCKDIV);
	LDI  R30,LOW(213)
	CALL SUBOPT_0x1
;  LCD_Commmand(COMAND, 0x80);
	LDI  R30,LOW(128)
	CALL SUBOPT_0x1
;  LCD_Commmand(COMAND, SSD1306_SETMULTIPLEX);
	LDI  R30,LOW(168)
	CALL SUBOPT_0x1
;  LCD_Commmand(COMAND, 0x3F);
	LDI  R30,LOW(63)
	CALL SUBOPT_0x1
;  LCD_Commmand(COMAND, SSD1306_SETDISPLAYOFFSET);
	LDI  R30,LOW(211)
	CALL SUBOPT_0x1
;  LCD_Commmand(COMAND, 0x00);
	LDI  R30,LOW(0)
	CALL SUBOPT_0x1
;  LCD_Commmand(COMAND, SSD1306_SETSTARTLINE | 0x00);
	LDI  R30,LOW(64)
	CALL SUBOPT_0x1
;    // We use internal charge pump
;  LCD_Commmand(COMAND, SSD1306_CHARGEPUMP);
	LDI  R30,LOW(141)
	CALL SUBOPT_0x1
;  LCD_Commmand(COMAND, 0x14);
	LDI  R30,LOW(20)
	CALL SUBOPT_0x1
;    // Horizontal memory mode
;  LCD_Commmand(COMAND, SSD1306_MEMORYMODE);
	LDI  R30,LOW(32)
	CALL SUBOPT_0x1
;  LCD_Commmand(COMAND, 0x00);
	LDI  R30,LOW(0)
	CALL SUBOPT_0x1
;  LCD_Commmand(COMAND, SSD1306_SEGREMAP | 0x1);
	LDI  R30,LOW(161)
	CALL SUBOPT_0x1
;  LCD_Commmand(COMAND, SSD1306_COMSCANDEC);
	LDI  R30,LOW(200)
	CALL SUBOPT_0x1
;  LCD_Commmand(COMAND, SSD1306_SETCOMPINS);
	LDI  R30,LOW(218)
	CALL SUBOPT_0x1
;  LCD_Commmand(COMAND, 0x12);
	LDI  R30,LOW(18)
	CALL SUBOPT_0x1
;    // Max contrast
;  LCD_Commmand(COMAND, SSD1306_SETCONTRAST);
	LDI  R30,LOW(129)
	CALL SUBOPT_0x1
;  LCD_Commmand(COMAND, 0xCF);
	LDI  R30,LOW(207)
	CALL SUBOPT_0x1
;  LCD_Commmand(COMAND, SSD1306_SETPRECHARGE);
	LDI  R30,LOW(217)
	CALL SUBOPT_0x1
;  LCD_Commmand(COMAND, 0xF1);
	LDI  R30,LOW(241)
	CALL SUBOPT_0x1
;  LCD_Commmand(COMAND, SSD1306_SETVCOMDETECT);
	LDI  R30,LOW(219)
	CALL SUBOPT_0x1
;  LCD_Commmand(COMAND, 0x40);
	LDI  R30,LOW(64)
	CALL SUBOPT_0x1
;  LCD_Commmand(COMAND, SSD1306_DISPLAYALLON_RESUME);
	LDI  R30,LOW(164)
	CALL SUBOPT_0x1
;    // Non-inverted display
;  LCD_Mode(0);
	RCALL _LCD_Mode
;    // Turn display back on
;  LCD_Sleep(1);
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _LCD_Sleep
;
;  LCD_Clear();
	RCALL _LCD_Clear
;  LCD_Goto(0,0);
	CALL SUBOPT_0x2
;}
	RET
;
;void LCD_Contrast(char set_contrast)
;{
_LCD_Contrast:
;  LCD_Commmand(COMAND, SSD1306_DISPLAYOFF);
;	set_contrast -> Y+0
	CALL SUBOPT_0x3
;  delay_ms(10);
	CALL SUBOPT_0x0
;  LCD_Commmand(COMAND, SSD1306_SETCONTRAST);
	LDI  R30,LOW(129)
	CALL SUBOPT_0x1
;  LCD_Commmand(COMAND, set_contrast);
	LDD  R30,Y+1
	CALL SUBOPT_0x1
;  LCD_Commmand(COMAND, SSD1306_DISPLAYON);
	LDI  R30,LOW(175)
	ST   -Y,R30
	RCALL _LCD_Commmand
;}
	RJMP _0x20A000B
;
;void LCD_Mode(char set_mode)
;{
_LCD_Mode:
; if(set_mode==0){ LCD_Commmand(COMAND, SSD1306_NORMALDISPLAY); }
;	set_mode -> Y+0
	LD   R30,Y
	CPI  R30,0
	BRNE _0x3
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(166)
	ST   -Y,R30
	RCALL _LCD_Commmand
; if(set_mode==1){ LCD_Commmand(COMAND, SSD1306_INVERTDISPLAY); }
_0x3:
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x4
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(167)
	ST   -Y,R30
	RCALL _LCD_Commmand
;}
_0x4:
	RJMP _0x20A000B
;
;void LCD_Sleep(char set)
;{
_LCD_Sleep:
;  if(set==0){LCD_Commmand(COMAND,SSD1306_DISPLAYOFF);}
;	set -> Y+0
	LD   R30,Y
	CPI  R30,0
	BRNE _0x5
	CALL SUBOPT_0x3
;  if(set==1){LCD_Commmand(COMAND,SSD1306_DISPLAYON);}
_0x5:
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x6
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(175)
	ST   -Y,R30
	RCALL _LCD_Commmand
;}
_0x6:
_0x20A000B:
	ADIW R28,1
	RET
;
;void LCD_Commmand(unsigned char ControByte, unsigned char DataByte)
;{
_LCD_Commmand:
;  i2c_start();
;	ControByte -> Y+1
;	DataByte -> Y+0
	CALL SUBOPT_0x4
;  i2c_write(SSD1306_I2C_ADDRESS);
;  i2c_write(ControByte);
	LDD  R30,Y+1
	ST   -Y,R30
	CALL _i2c_write
;  i2c_write(DataByte);
	LD   R30,Y
	CALL SUBOPT_0x5
;  i2c_stop();
;}
	RJMP _0x20A000A
;
;void LCD_Goto(unsigned char x, unsigned char y)
;{
_LCD_Goto:
;	LCD_X = x;
;	x -> Y+1
;	y -> Y+0
	CALL SUBOPT_0x6
;	LCD_Y = y;
;
;	//    
;	LCD_Commmand(COMAND, 0xB0 + y);//   
;	LCD_Commmand(COMAND, x & 0xf);//   
	LDD  R30,Y+2
	ANDI R30,LOW(0xF)
	CALL SUBOPT_0x1
;	LCD_Commmand(COMAND,0x10 | (x >> 4));//   
	LDD  R30,Y+2
	LDI  R31,0
	RJMP _0x20A0009
;}
;
;void LCD_Goto2X(unsigned char x, unsigned char y)
;{
_LCD_Goto2X:
;	LCD_X = x;
;	x -> Y+1
;	y -> Y+0
	CALL SUBOPT_0x6
;	LCD_Y = y;
;
;	//    
;	LCD_Commmand(COMAND, 0xB0 + y);//   
;	LCD_Commmand(COMAND, 2*x & 0xf);//   
	LDD  R30,Y+2
	LSL  R30
	ANDI R30,LOW(0xF)
	CALL SUBOPT_0x1
;	LCD_Commmand(COMAND,0x10 | (2*x >> 4));//   
	LDD  R30,Y+2
	LDI  R26,LOW(2)
	MUL  R30,R26
	MOVW R30,R0
_0x20A0009:
	CALL __ASRW4
	ORI  R30,0x10
	ST   -Y,R30
	RCALL _LCD_Commmand
;}
_0x20A000A:
	ADIW R28,2
	RET
;
;void LCD_Clear(void)
;{
_LCD_Clear:
;	unsigned short i;
;	unsigned short x=0;
;	unsigned short y=0;
;	LCD_Goto(0,0);
	CALL __SAVELOCR6
;	i -> R16,R17
;	x -> R18,R19
;	y -> R20,R21
	__GETWRN 18,19,0
	__GETWRN 20,21,0
	CALL SUBOPT_0x2
;
;	for (i=0; i<(SSD1306_LCDWIDTH*SSD1306_LCDHEIGHT/8); i++) //(SSD1306_LCDWIDTH*SSD1306_LCDHEIGHT/8)
	__GETWRN 16,17,0
_0x8:
	__CPWRN 16,17,1024
	BRSH _0x9
;	{
;		LCD_Char(' ');
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _LCD_Char
;		x ++;
	__ADDWRN 18,19,1
;		if(x>SSD1306_LCDWIDTH)
	__CPWRN 18,19,129
	BRLO _0xA
;		{
;			x =0;
	__GETWRN 18,19,0
;			y++;
	__ADDWRN 20,21,1
;			LCD_Goto(0,y);
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R20
	RCALL _LCD_Goto
;		}
;	}
_0xA:
	__ADDWRN 16,17,1
	RJMP _0x8
_0x9:
;	LCD_X =SSD1306_DEFAULT_SPACE;
	LDI  R30,LOW(5)
	MOV  R4,R30
;	LCD_Y =0;
	CLR  R3
;}
	CALL __LOADLOCR6
	RJMP _0x20A0008
;
;void LCD_Char(unsigned int c)
;{
_LCD_Char:
;  unsigned char x = 0;
;  i2c_start();
	ST   -Y,R17
;	c -> Y+1
;	x -> R17
	LDI  R17,0
	CALL SUBOPT_0x4
;  i2c_write(SSD1306_I2C_ADDRESS);
;  i2c_write(DATA);//data mode
	CALL SUBOPT_0x7
;  for (x=0; x<5; x++)
_0xC:
	CPI  R17,5
	BRSH _0xD
;	{
;     i2c_write(LCD_Buffer[c*5+x]);
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	CALL SUBOPT_0x8
	LPM  R30,Z
	ST   -Y,R30
	CALL _i2c_write
;     }
	SUBI R17,-1
	RJMP _0xC
_0xD:
;  i2c_write(0x00);  //     
	LDI  R30,LOW(0)
	CALL SUBOPT_0x5
;  i2c_stop();    // stop transmitting
;
;	LCD_X += 8;
	LDI  R30,LOW(8)
	ADD  R4,R30
;	if(LCD_X>SSD1306_LCDWIDTH)
	LDI  R30,LOW(128)
	CP   R30,R4
	BRSH _0xE
;	{
;		LCD_X = SSD1306_DEFAULT_SPACE;
	LDI  R30,LOW(5)
	MOV  R4,R30
;	}
;}
_0xE:
	LDD  R17,Y+0
	RJMP _0x20A0007
;
;void LCD_BigNum(unsigned char num)
;{
_LCD_BigNum:
;  unsigned char x = 0;
;  unsigned char z = 0;
;
;  unsigned char y_s = LCD_Y;
;
;  if(num!=46&&num!=32&&num!=32&&num!=67){num = num - 48;}
	CALL __SAVELOCR4
;	num -> Y+4
;	x -> R17
;	z -> R16
;	y_s -> R19
	LDI  R17,0
	LDI  R16,0
	MOV  R19,R3
	LDD  R26,Y+4
	CPI  R26,LOW(0x2E)
	BREQ _0x10
	CPI  R26,LOW(0x20)
	BREQ _0x10
	CPI  R26,LOW(0x20)
	BREQ _0x10
	CPI  R26,LOW(0x43)
	BRNE _0x11
_0x10:
	RJMP _0xF
_0x11:
	LDD  R30,Y+4
	LDI  R31,0
	SBIW R30,48
	RJMP _0x49
;  else
_0xF:
;   {
;   if(num==46){ num = 11; }  // .
	LDD  R26,Y+4
	CPI  R26,LOW(0x2E)
	BRNE _0x13
	LDI  R30,LOW(11)
	STD  Y+4,R30
;   if(num==32){ num = 12; }  // space
_0x13:
	LDD  R26,Y+4
	CPI  R26,LOW(0x20)
	BRNE _0x14
	LDI  R30,LOW(12)
	STD  Y+4,R30
;   if(num==67){ num = 13; }  // 
_0x14:
	LDD  R26,Y+4
	CPI  R26,LOW(0x43)
	BRNE _0x15
	LDI  R30,LOW(13)
_0x49:
	STD  Y+4,R30
;   }
_0x15:
;
;  i2c_start();
	CALL SUBOPT_0x4
;  i2c_write(SSD1306_I2C_ADDRESS);
;  i2c_write(DATA);//data mode
	CALL SUBOPT_0x7
;  for (x=0; x<96; x++)
_0x17:
	CPI  R17,96
	BRSH _0x18
;	{
;     i2c_write(BigNum[num][x]);
	LDD  R30,Y+4
	LDI  R26,LOW(96)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_BigNum*2)
	SBCI R31,HIGH(-_BigNum*2)
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	ST   -Y,R30
	CALL _i2c_write
;     if(z>=23)
	CPI  R16,23
	BRLO _0x19
;     {
;       i2c_stop();    // stop transmitting
	CALL _i2c_stop
;       LCD_Goto(LCD_X,LCD_Y+1);
	ST   -Y,R4
	MOV  R30,R3
	SUBI R30,-LOW(1)
	ST   -Y,R30
	RCALL _LCD_Goto
;
;       z=0;
	LDI  R16,LOW(0)
;       i2c_start();
	CALL SUBOPT_0x4
;       i2c_write(SSD1306_I2C_ADDRESS);
;       i2c_write(DATA);//data mode
	LDI  R30,LOW(64)
	ST   -Y,R30
	CALL _i2c_write
;     }else{z++;}
	RJMP _0x1A
_0x19:
	SUBI R16,-1
_0x1A:
;
;     }
	SUBI R17,-1
	RJMP _0x17
_0x18:
;  i2c_stop();    // stop transmitting
	CALL _i2c_stop
;
;	LCD_X += 23;
	LDI  R30,LOW(23)
	ADD  R4,R30
;    LCD_Goto(LCD_X,y_s);
	ST   -Y,R4
	ST   -Y,R19
	RCALL _LCD_Goto
;    if(LCD_X>SSD1306_LCDWIDTH)
	LDI  R30,LOW(128)
	CP   R30,R4
	BRSH _0x1B
;	{
;		LCD_X = SSD1306_DEFAULT_SPACE;
	LDI  R30,LOW(5)
	MOV  R4,R30
;	}
;}
_0x1B:
	CALL __LOADLOCR4
	RJMP _0x20A0006
;
;void LCD_CharBig(unsigned int c)
;{
_LCD_CharBig:
;  unsigned char x = 0;
;  unsigned int m = 0;
;
;  i2c_start();
	CALL __SAVELOCR4
;	c -> Y+4
;	x -> R17
;	m -> R18,R19
	LDI  R17,0
	__GETWRN 18,19,0
	CALL SUBOPT_0x4
;  i2c_write(SSD1306_I2C_ADDRESS);
;  i2c_write(DATA);//data mode
	CALL SUBOPT_0x7
;  for (x=0; x<5; x++)
_0x1D:
	CPI  R17,5
	BRSH _0x1E
;	{
;     m = LCD_Buffer[c*5+x];
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL SUBOPT_0x8
	LPM  R18,Z
	CLR  R19
;     i2c_write(m);
	ST   -Y,R18
	CALL _i2c_write
;     i2c_write(m);
	ST   -Y,R18
	CALL _i2c_write
;     }
	SUBI R17,-1
	RJMP _0x1D
_0x1E:
;  i2c_write(0x00);  //     
	LDI  R30,LOW(0)
	CALL SUBOPT_0x5
;  i2c_stop();    // stop transmitting
;	LCD_X += 11;
	LDI  R30,LOW(11)
	ADD  R4,R30
;	if(LCD_X>SSD1306_LCDWIDTH)
	LDI  R30,LOW(128)
	CP   R30,R4
	BRSH _0x1F
;	{
;		LCD_X = SSD1306_DEFAULT_SPACE;
	LDI  R30,LOW(5)
	MOV  R4,R30
;	}
;}
_0x1F:
	CALL __LOADLOCR4
_0x20A0008:
	ADIW R28,6
	RET
;
;void LCD_Printf(unsigned char* buf, unsigned char size) //   
;{
_LCD_Printf:
;
;	while (*buf!=0)
;	*buf -> Y+1
;	size -> Y+0
_0x20:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X
	CPI  R30,0
	BREQ _0x22
;	{
;       if(size==0)
	LD   R30,Y
	CPI  R30,0
	BRNE _0x23
;       {
;		if((LCD_X>SSD1306_LCDWIDTH)||(LCD_X<5)){LCD_X=SSD1306_DEFAULT_SPACE;}
	LDI  R30,LOW(128)
	CP   R30,R4
	BRLO _0x25
	LDI  R30,LOW(5)
	CP   R4,R30
	BRSH _0x24
_0x25:
	LDI  R30,LOW(5)
	MOV  R4,R30
;		LCD_Char(*buf++);
_0x24:
	CALL SUBOPT_0x9
	RCALL _LCD_Char
;        }
;       if(size==1)
_0x23:
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x27
;       {
;        if((LCD_X>SSD1306_LCDWIDTH)||(LCD_X<5)){LCD_X=SSD1306_DEFAULT_SPACE;}
	LDI  R30,LOW(128)
	CP   R30,R4
	BRLO _0x29
	LDI  R30,LOW(5)
	CP   R4,R30
	BRSH _0x28
_0x29:
	LDI  R30,LOW(5)
	MOV  R4,R30
;        LCD_CharBig(*buf++);
_0x28:
	CALL SUBOPT_0x9
	RCALL _LCD_CharBig
;       }
;       if(size==2)
_0x27:
	LD   R26,Y
	CPI  R26,LOW(0x2)
	BRNE _0x2B
;       {
;        if((LCD_X>SSD1306_LCDWIDTH)||(LCD_X<24)){LCD_X=SSD1306_DEFAULT_SPACE;}
	LDI  R30,LOW(128)
	CP   R30,R4
	BRLO _0x2D
	LDI  R30,LOW(24)
	CP   R4,R30
	BRSH _0x2C
_0x2D:
	LDI  R30,LOW(5)
	MOV  R4,R30
;        LCD_BigNum(*buf++);
_0x2C:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	ST   -Y,R30
	RCALL _LCD_BigNum
;       }
;	}
_0x2B:
	RJMP _0x20
_0x22:
;}
_0x20A0007:
	ADIW R28,3
	RET
;
;void LCD_DrawImage(unsigned char num_image)
;{
_LCD_DrawImage:
;	unsigned int i;
;	unsigned char x=0;
;	unsigned char y=0;
;	LCD_Goto(0,0);
	CALL __SAVELOCR4
;	num_image -> Y+4
;	i -> R16,R17
;	x -> R19
;	y -> R18
	LDI  R19,0
	LDI  R18,0
	CALL SUBOPT_0x2
;
;	for (i=0; i<(SSD1306_LCDWIDTH*SSD1306_LCDHEIGHT/8); i++)
	__GETWRN 16,17,0
_0x30:
	__CPWRN 16,17,1024
	BRSH _0x31
;	{
;        if(num_image==0)
	LDD  R30,Y+4
	CPI  R30,0
	BRNE _0x32
;        {
;		LCD_Commmand(DATA, image0[i]);
	LDI  R30,LOW(64)
	ST   -Y,R30
	MOVW R30,R16
	SUBI R30,LOW(-_image0*2)
	SBCI R31,HIGH(-_image0*2)
	LPM  R30,Z
	ST   -Y,R30
	RCALL _LCD_Commmand
;        }
;
;		x++;
_0x32:
	SUBI R19,-1
;		if(x>=SSD1306_LCDWIDTH)
	CPI  R19,128
	BRLO _0x33
;		{
;			x=0;
	LDI  R19,LOW(0)
;			y++;
	SUBI R18,-1
;			LCD_Goto(0,y);
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R18
	RCALL _LCD_Goto
;		}
;	}
_0x33:
	__ADDWRN 16,17,1
	RJMP _0x30
_0x31:
;}
	CALL __LOADLOCR4
	RJMP _0x20A0006
;
;void LCD_Bat(unsigned char y,unsigned char x, unsigned char z)
;{
_LCD_Bat:
; unsigned char i=0;
;
; LCD_Goto2X(x-1,y);
	ST   -Y,R17
;	y -> Y+3
;	x -> Y+2
;	z -> Y+1
;	i -> R17
	LDI  R17,0
	LDD  R30,Y+2
	LDI  R31,0
	SBIW R30,1
	CALL SUBOPT_0xA
; LCD_Commmand(DATA, 0xFF); LCD_Commmand(DATA, 0xFF);
	CALL SUBOPT_0xB
	CALL SUBOPT_0xB
; LCD_Goto2X(x+2,y);
	LDD  R30,Y+2
	SUBI R30,-LOW(2)
	CALL SUBOPT_0xA
;for (i=0; i<14; i++)
	LDI  R17,LOW(0)
_0x35:
	CPI  R17,14
	BRSH _0x36
;	{
;       if(i<11)
	CPI  R17,11
	BRSH _0x37
;       {
;         if(z>=i){ LCD_Commmand(DATA, 0xBD); }
	LDD  R26,Y+1
	CP   R26,R17
	BRLO _0x38
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(189)
	RJMP _0x4A
;         else    { LCD_Commmand(DATA, 0x81); LCD_Commmand(DATA, 0x81); }
_0x38:
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(129)
	CALL SUBOPT_0xC
	LDI  R30,LOW(129)
_0x4A:
	ST   -Y,R30
	RCALL _LCD_Commmand
;       }
;       if(i==11)      {LCD_Commmand(DATA, 0xFF); LCD_Commmand(DATA, 0xFF);}
_0x37:
	CPI  R17,11
	BRNE _0x3A
	CALL SUBOPT_0xB
	CALL SUBOPT_0xB
;       if(i==12)      {LCD_Commmand(DATA, 0x3C); LCD_Commmand(DATA, 0x3C);}
_0x3A:
	CPI  R17,12
	BRNE _0x3B
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(60)
	CALL SUBOPT_0xC
	LDI  R30,LOW(60)
	ST   -Y,R30
	RCALL _LCD_Commmand
;       if(i==13)      {LCD_Commmand(DATA, 0x3C); LCD_Commmand(DATA, 0x3C);}
_0x3B:
	CPI  R17,13
	BRNE _0x3C
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(60)
	CALL SUBOPT_0xC
	LDI  R30,LOW(60)
	ST   -Y,R30
	RCALL _LCD_Commmand
;       LCD_Goto2X(x+i,y);
_0x3C:
	MOV  R30,R17
	LDD  R26,Y+2
	ADD  R30,R26
	CALL SUBOPT_0xA
;	}
	SUBI R17,-1
	RJMP _0x35
_0x36:
;
;}
	LDD  R17,Y+0
	JMP  _0x20A0003
;
;
;
;
;
;
;#define PWR_LCD PORTD.4
;
;unsigned int out=0;
;float t=0;
;
;char buff[40];  // 
;
;
;void main(void)
; 0000 002D {
_main:
; 0000 002E // Crystal Oscillator division factor: 1
; 0000 002F #pragma optsize-
; 0000 0030 CLKPR=0x80;
	LDI  R30,LOW(128)
	STS  97,R30
; 0000 0031 CLKPR=0x00;
	LDI  R30,LOW(0)
	STS  97,R30
; 0000 0032 #ifdef _OPTIMIZE_SIZE_
; 0000 0033 #pragma optsize+
; 0000 0034 #endif
; 0000 0035 
; 0000 0036 // Input/Output Ports initialization
; 0000 0037 // Port B initialization
; 0000 0038 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0039 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 003A PORTB=0x00;
	OUT  0x5,R30
; 0000 003B DDRB=0x00;
	OUT  0x4,R30
; 0000 003C 
; 0000 003D // Port C initialization
; 0000 003E // Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 003F // State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0040 PORTC=0x00;
	OUT  0x8,R30
; 0000 0041 DDRC=0x00;
	OUT  0x7,R30
; 0000 0042 
; 0000 0043 // Port D initialization
; 0000 0044 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0045 // State7=T State6=P State5=P State4=T State3=T State2=T State1=T State0=T
; 0000 0046 PORTD=0x60;
	LDI  R30,LOW(96)
	OUT  0xB,R30
; 0000 0047 DDRD=0x00;
	LDI  R30,LOW(0)
	OUT  0xA,R30
; 0000 0048 DDRD.4=1;
	SBI  0xA,4
; 0000 0049 PWR_LCD=0;
	CBI  0xB,4
; 0000 004A // I2C Bus initialization
; 0000 004B i2c_init();
	CALL _i2c_init
; 0000 004C        PWR_LCD=1;
	SBI  0xB,4
; 0000 004D        LCD_init();
	RCALL _LCD_init
; 0000 004E        LCD_DrawImage(0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _LCD_DrawImage
; 0000 004F        delay_ms(5000);
	LDI  R30,LOW(5000)
	LDI  R31,HIGH(5000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 0050        LCD_Clear();
	RCALL _LCD_Clear
; 0000 0051         LCD_Contrast(1);
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _LCD_Contrast
; 0000 0052 
; 0000 0053 while (1)
_0x43:
; 0000 0054       {
; 0000 0055        delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 0056 
; 0000 0057        LCD_Goto(0,0);
	CALL SUBOPT_0x2
; 0000 0058        sprintf(buff,"X=%i ",out);
	CALL SUBOPT_0xD
	__POINTW1FN _0x0,0
	ST   -Y,R31
	ST   -Y,R30
	__GETW1R 5,6
	CLR  R22
	CLR  R23
	CALL SUBOPT_0xE
; 0000 0059        LCD_Printf(buff,1);  //    
	CALL SUBOPT_0xF
; 0000 005A 
; 0000 005B         LCD_Goto(0,1);
	LDI  R30,LOW(1)
	CALL SUBOPT_0x10
; 0000 005C        sprintf(buff,"  SSD1306");
	__POINTW1FN _0x0,6
	CALL SUBOPT_0x11
; 0000 005D        LCD_Printf(buff,0);  //    
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _LCD_Printf
; 0000 005E 
; 0000 005F        LCD_Goto(5,2);
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(2)
	CALL SUBOPT_0x10
; 0000 0060        sprintf(buff,"%.1f:C",t);
	__POINTW1FN _0x0,24
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x12
	CALL SUBOPT_0xE
; 0000 0061        LCD_Printf(buff,2);  //    
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _LCD_Printf
; 0000 0062 
; 0000 0063        LCD_Bat(0,110,out);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(110)
	ST   -Y,R30
	ST   -Y,R5
	RCALL _LCD_Bat
; 0000 0064 
; 0000 0065        out++; t=t+0.1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 5,6,30,31
	CALL SUBOPT_0x12
	__GETD2N 0x3DCCCCCD
	CALL __ADDF12
	CALL SUBOPT_0x13
; 0000 0066        if(t>9.9){t=0.1;}
	LDS  R26,_t
	LDS  R27,_t+1
	LDS  R24,_t+2
	LDS  R25,_t+3
	__GETD1N 0x411E6666
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x46
	CALL SUBOPT_0x14
	CALL SUBOPT_0x13
; 0000 0067        if(out>10){out=0;}
_0x46:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CP   R30,R5
	CPC  R31,R6
	BRSH _0x47
	CLR  R5
	CLR  R6
; 0000 0068 
; 0000 0069        LCD_Goto(1,6);
_0x47:
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(6)
	CALL SUBOPT_0x10
; 0000 006A        sprintf(buff,"12345678910");
	__POINTW1FN _0x0,31
	CALL SUBOPT_0x11
; 0000 006B        LCD_Printf(buff,1);  //    
	CALL SUBOPT_0xF
; 0000 006C 
; 0000 006D        LCD_Goto(0,7);
	LDI  R30,LOW(7)
	CALL SUBOPT_0x10
; 0000 006E        sprintf(buff," 8");
	__POINTW1FN _0x0,43
	CALL SUBOPT_0x11
; 0000 006F        LCD_Printf(buff,0);  //    
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _LCD_Printf
; 0000 0070 
; 0000 0071 
; 0000 0072       }
	RJMP _0x43
; 0000 0073 }
_0x48:
	RJMP _0x48
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.SET power_ctrl_reg=smcr
	#endif

	.CSEG
_put_buff_G100:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2000016
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2000018
	__CPWRN 16,17,2
	BRLO _0x2000019
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2000018:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL SUBOPT_0x15
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	TST  R31
	BRMI _0x200001A
	CALL SUBOPT_0x15
_0x200001A:
_0x2000019:
	RJMP _0x200001B
_0x2000016:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x200001B:
	LDD  R17,Y+1
	LDD  R16,Y+0
_0x20A0006:
	ADIW R28,5
	RET
__ftoe_G100:
	SBIW R28,4
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	LDI  R30,LOW(128)
	STD  Y+2,R30
	LDI  R30,LOW(63)
	STD  Y+3,R30
	CALL __SAVELOCR4
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x200001F
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2000000,0
	CALL SUBOPT_0x16
	RJMP _0x20A0005
_0x200001F:
	CPI  R30,LOW(0x7FFF)
	LDI  R26,HIGH(0x7FFF)
	CPC  R31,R26
	BRNE _0x200001E
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2000000,1
	CALL SUBOPT_0x16
	RJMP _0x20A0005
_0x200001E:
	LDD  R26,Y+11
	CPI  R26,LOW(0x7)
	BRLO _0x2000021
	LDI  R30,LOW(6)
	STD  Y+11,R30
_0x2000021:
	LDD  R17,Y+11
_0x2000022:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x2000024
	CALL SUBOPT_0x17
	RJMP _0x2000022
_0x2000024:
	__GETD1S 12
	CALL __CPD10
	BRNE _0x2000025
	LDI  R19,LOW(0)
	CALL SUBOPT_0x17
	RJMP _0x2000026
_0x2000025:
	LDD  R19,Y+11
	CALL SUBOPT_0x18
	BREQ PC+2
	BRCC PC+3
	JMP  _0x2000027
	CALL SUBOPT_0x17
_0x2000028:
	CALL SUBOPT_0x18
	BRLO _0x200002A
	CALL SUBOPT_0x19
	CALL SUBOPT_0x1A
	RJMP _0x2000028
_0x200002A:
	RJMP _0x200002B
_0x2000027:
_0x200002C:
	CALL SUBOPT_0x18
	BRSH _0x200002E
	CALL SUBOPT_0x19
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x1C
	SUBI R19,LOW(1)
	RJMP _0x200002C
_0x200002E:
	CALL SUBOPT_0x17
_0x200002B:
	__GETD1S 12
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1C
	CALL SUBOPT_0x18
	BRLO _0x200002F
	CALL SUBOPT_0x19
	CALL SUBOPT_0x1A
_0x200002F:
_0x2000026:
	LDI  R17,LOW(0)
_0x2000030:
	LDD  R30,Y+11
	CP   R30,R17
	BRLO _0x2000032
	__GETD2S 4
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x1D
	CALL __PUTPARD1
	CALL _floor
	__PUTD1S 4
	CALL SUBOPT_0x19
	CALL __DIVF21
	CALL __CFD1U
	MOV  R16,R30
	CALL SUBOPT_0x1F
	CALL SUBOPT_0x20
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	__GETD2S 4
	CALL __MULF12
	CALL SUBOPT_0x19
	CALL SUBOPT_0x21
	CALL SUBOPT_0x1C
	MOV  R30,R17
	SUBI R17,-1
	CPI  R30,0
	BRNE _0x2000030
	CALL SUBOPT_0x1F
	LDI  R30,LOW(46)
	ST   X,R30
	RJMP _0x2000030
_0x2000032:
	CALL SUBOPT_0x22
	SBIW R30,1
	LDD  R26,Y+10
	STD  Z+0,R26
	CPI  R19,0
	BRGE _0x2000034
	NEG  R19
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(45)
	RJMP _0x2000114
_0x2000034:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(43)
_0x2000114:
	ST   X,R30
	CALL SUBOPT_0x22
	CALL SUBOPT_0x22
	SBIW R30,1
	MOVW R22,R30
	MOV  R26,R19
	LDI  R30,LOW(10)
	CALL __DIVB21
	SUBI R30,-LOW(48)
	MOVW R26,R22
	ST   X,R30
	CALL SUBOPT_0x22
	SBIW R30,1
	MOVW R22,R30
	MOV  R26,R19
	LDI  R30,LOW(10)
	CALL __MODB21
	SUBI R30,-LOW(48)
	MOVW R26,R22
	ST   X,R30
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(0)
	ST   X,R30
_0x20A0005:
	CALL __LOADLOCR4
	ADIW R28,16
	RET
__print_G100:
	SBIW R28,63
	SBIW R28,17
	CALL __SAVELOCR6
	LDI  R17,0
	__GETW1SX 88
	STD  Y+8,R30
	STD  Y+8+1,R31
	__GETW1SX 86
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2000036:
	MOVW R26,R28
	SUBI R26,LOW(-(92))
	SBCI R27,HIGH(-(92))
	CALL SUBOPT_0x15
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x2000038
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x200003C
	CPI  R18,37
	BRNE _0x200003D
	LDI  R17,LOW(1)
	RJMP _0x200003E
_0x200003D:
	CALL SUBOPT_0x23
_0x200003E:
	RJMP _0x200003B
_0x200003C:
	CPI  R30,LOW(0x1)
	BRNE _0x200003F
	CPI  R18,37
	BRNE _0x2000040
	CALL SUBOPT_0x23
	RJMP _0x2000115
_0x2000040:
	LDI  R17,LOW(2)
	LDI  R30,LOW(0)
	STD  Y+21,R30
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2000041
	LDI  R16,LOW(1)
	RJMP _0x200003B
_0x2000041:
	CPI  R18,43
	BRNE _0x2000042
	LDI  R30,LOW(43)
	STD  Y+21,R30
	RJMP _0x200003B
_0x2000042:
	CPI  R18,32
	BRNE _0x2000043
	LDI  R30,LOW(32)
	STD  Y+21,R30
	RJMP _0x200003B
_0x2000043:
	RJMP _0x2000044
_0x200003F:
	CPI  R30,LOW(0x2)
	BRNE _0x2000045
_0x2000044:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2000046
	ORI  R16,LOW(128)
	RJMP _0x200003B
_0x2000046:
	RJMP _0x2000047
_0x2000045:
	CPI  R30,LOW(0x3)
	BRNE _0x2000048
_0x2000047:
	CPI  R18,48
	BRLO _0x200004A
	CPI  R18,58
	BRLO _0x200004B
_0x200004A:
	RJMP _0x2000049
_0x200004B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x200003B
_0x2000049:
	LDI  R20,LOW(0)
	CPI  R18,46
	BRNE _0x200004C
	LDI  R17,LOW(4)
	RJMP _0x200003B
_0x200004C:
	RJMP _0x200004D
_0x2000048:
	CPI  R30,LOW(0x4)
	BRNE _0x200004F
	CPI  R18,48
	BRLO _0x2000051
	CPI  R18,58
	BRLO _0x2000052
_0x2000051:
	RJMP _0x2000050
_0x2000052:
	ORI  R16,LOW(32)
	LDI  R26,LOW(10)
	MUL  R20,R26
	MOV  R20,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x200003B
_0x2000050:
_0x200004D:
	CPI  R18,108
	BRNE _0x2000053
	ORI  R16,LOW(2)
	LDI  R17,LOW(5)
	RJMP _0x200003B
_0x2000053:
	RJMP _0x2000054
_0x200004F:
	CPI  R30,LOW(0x5)
	BREQ PC+3
	JMP _0x200003B
_0x2000054:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x2000059
	CALL SUBOPT_0x24
	CALL SUBOPT_0x25
	CALL SUBOPT_0x24
	LDD  R26,Z+4
	ST   -Y,R26
	CALL SUBOPT_0x26
	RJMP _0x200005A
_0x2000059:
	CPI  R30,LOW(0x45)
	BREQ _0x200005D
	CPI  R30,LOW(0x65)
	BRNE _0x200005E
_0x200005D:
	RJMP _0x200005F
_0x200005E:
	CPI  R30,LOW(0x66)
	BREQ PC+3
	JMP _0x2000060
_0x200005F:
	MOVW R30,R28
	ADIW R30,22
	STD  Y+14,R30
	STD  Y+14+1,R31
	CALL SUBOPT_0x27
	CALL __GETD1P
	CALL SUBOPT_0x28
	CALL SUBOPT_0x29
	LDD  R26,Y+13
	TST  R26
	BRMI _0x2000061
	LDD  R26,Y+21
	CPI  R26,LOW(0x2B)
	BREQ _0x2000063
	RJMP _0x2000064
_0x2000061:
	CALL SUBOPT_0x2A
	CALL __ANEGF1
	CALL SUBOPT_0x28
	LDI  R30,LOW(45)
	STD  Y+21,R30
_0x2000063:
	SBRS R16,7
	RJMP _0x2000065
	LDD  R30,Y+21
	ST   -Y,R30
	CALL SUBOPT_0x26
	RJMP _0x2000066
_0x2000065:
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	ADIW R30,1
	STD  Y+14,R30
	STD  Y+14+1,R31
	SBIW R30,1
	LDD  R26,Y+21
	STD  Z+0,R26
_0x2000066:
_0x2000064:
	SBRS R16,5
	LDI  R20,LOW(6)
	CPI  R18,102
	BRNE _0x2000068
	CALL SUBOPT_0x2A
	CALL __PUTPARD1
	ST   -Y,R20
	LDD  R30,Y+19
	LDD  R31,Y+19+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _ftoa
	RJMP _0x2000069
_0x2000068:
	CALL SUBOPT_0x2A
	CALL __PUTPARD1
	ST   -Y,R20
	ST   -Y,R18
	LDD  R30,Y+20
	LDD  R31,Y+20+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL __ftoe_G100
_0x2000069:
	MOVW R30,R28
	ADIW R30,22
	CALL SUBOPT_0x2B
	RJMP _0x200006A
_0x2000060:
	CPI  R30,LOW(0x73)
	BRNE _0x200006C
	CALL SUBOPT_0x29
	CALL SUBOPT_0x2C
	CALL SUBOPT_0x2B
	RJMP _0x200006D
_0x200006C:
	CPI  R30,LOW(0x70)
	BRNE _0x200006F
	CALL SUBOPT_0x29
	CALL SUBOPT_0x2C
	STD  Y+14,R30
	STD  Y+14+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x200006D:
	ANDI R16,LOW(127)
	CPI  R20,0
	BREQ _0x2000071
	CP   R20,R17
	BRLO _0x2000072
_0x2000071:
	RJMP _0x2000070
_0x2000072:
	MOV  R17,R20
_0x2000070:
_0x200006A:
	LDI  R20,LOW(0)
	LDI  R30,LOW(0)
	STD  Y+20,R30
	LDI  R19,LOW(0)
	RJMP _0x2000073
_0x200006F:
	CPI  R30,LOW(0x64)
	BREQ _0x2000076
	CPI  R30,LOW(0x69)
	BRNE _0x2000077
_0x2000076:
	ORI  R16,LOW(4)
	RJMP _0x2000078
_0x2000077:
	CPI  R30,LOW(0x75)
	BRNE _0x2000079
_0x2000078:
	LDI  R30,LOW(10)
	STD  Y+20,R30
	SBRS R16,1
	RJMP _0x200007A
	__GETD1N 0x3B9ACA00
	CALL SUBOPT_0x2D
	LDI  R17,LOW(10)
	RJMP _0x200007B
_0x200007A:
	__GETD1N 0x2710
	CALL SUBOPT_0x2D
	LDI  R17,LOW(5)
	RJMP _0x200007B
_0x2000079:
	CPI  R30,LOW(0x58)
	BRNE _0x200007D
	ORI  R16,LOW(8)
	RJMP _0x200007E
_0x200007D:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x20000BC
_0x200007E:
	LDI  R30,LOW(16)
	STD  Y+20,R30
	SBRS R16,1
	RJMP _0x2000080
	__GETD1N 0x10000000
	CALL SUBOPT_0x2D
	LDI  R17,LOW(8)
	RJMP _0x200007B
_0x2000080:
	__GETD1N 0x1000
	CALL SUBOPT_0x2D
	LDI  R17,LOW(4)
_0x200007B:
	CPI  R20,0
	BREQ _0x2000081
	ANDI R16,LOW(127)
	RJMP _0x2000082
_0x2000081:
	LDI  R20,LOW(1)
_0x2000082:
	SBRS R16,1
	RJMP _0x2000083
	CALL SUBOPT_0x29
	CALL SUBOPT_0x27
	ADIW R26,4
	CALL __GETD1P
	RJMP _0x2000116
_0x2000083:
	SBRS R16,2
	RJMP _0x2000085
	CALL SUBOPT_0x29
	CALL SUBOPT_0x2C
	CALL __CWD1
	RJMP _0x2000116
_0x2000085:
	CALL SUBOPT_0x29
	CALL SUBOPT_0x2C
	CLR  R22
	CLR  R23
_0x2000116:
	__PUTD1S 10
	SBRS R16,2
	RJMP _0x2000087
	LDD  R26,Y+13
	TST  R26
	BRPL _0x2000088
	CALL SUBOPT_0x2A
	CALL __ANEGD1
	CALL SUBOPT_0x28
	LDI  R30,LOW(45)
	STD  Y+21,R30
_0x2000088:
	LDD  R30,Y+21
	CPI  R30,0
	BREQ _0x2000089
	SUBI R17,-LOW(1)
	SUBI R20,-LOW(1)
	RJMP _0x200008A
_0x2000089:
	ANDI R16,LOW(251)
_0x200008A:
_0x2000087:
	MOV  R19,R20
_0x2000073:
	SBRC R16,0
	RJMP _0x200008B
_0x200008C:
	CP   R17,R21
	BRSH _0x200008F
	CP   R19,R21
	BRLO _0x2000090
_0x200008F:
	RJMP _0x200008E
_0x2000090:
	SBRS R16,7
	RJMP _0x2000091
	SBRS R16,2
	RJMP _0x2000092
	ANDI R16,LOW(251)
	LDD  R18,Y+21
	SUBI R17,LOW(1)
	RJMP _0x2000093
_0x2000092:
	LDI  R18,LOW(48)
_0x2000093:
	RJMP _0x2000094
_0x2000091:
	LDI  R18,LOW(32)
_0x2000094:
	CALL SUBOPT_0x23
	SUBI R21,LOW(1)
	RJMP _0x200008C
_0x200008E:
_0x200008B:
_0x2000095:
	CP   R17,R20
	BRSH _0x2000097
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x2000098
	CALL SUBOPT_0x2E
	BREQ _0x2000099
	SUBI R21,LOW(1)
_0x2000099:
	SUBI R17,LOW(1)
	SUBI R20,LOW(1)
_0x2000098:
	LDI  R30,LOW(48)
	ST   -Y,R30
	CALL SUBOPT_0x26
	CPI  R21,0
	BREQ _0x200009A
	SUBI R21,LOW(1)
_0x200009A:
	SUBI R20,LOW(1)
	RJMP _0x2000095
_0x2000097:
	MOV  R19,R17
	LDD  R30,Y+20
	CPI  R30,0
	BRNE _0x200009B
_0x200009C:
	CPI  R19,0
	BREQ _0x200009E
	SBRS R16,3
	RJMP _0x200009F
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	LPM  R18,Z+
	STD  Y+14,R30
	STD  Y+14+1,R31
	RJMP _0x20000A0
_0x200009F:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	LD   R18,X+
	STD  Y+14,R26
	STD  Y+14+1,R27
_0x20000A0:
	CALL SUBOPT_0x23
	CPI  R21,0
	BREQ _0x20000A1
	SUBI R21,LOW(1)
_0x20000A1:
	SUBI R19,LOW(1)
	RJMP _0x200009C
_0x200009E:
	RJMP _0x20000A2
_0x200009B:
_0x20000A4:
	CALL SUBOPT_0x2F
	CALL __DIVD21U
	MOV  R18,R30
	CPI  R18,10
	BRLO _0x20000A6
	SBRS R16,3
	RJMP _0x20000A7
	SUBI R18,-LOW(55)
	RJMP _0x20000A8
_0x20000A7:
	SUBI R18,-LOW(87)
_0x20000A8:
	RJMP _0x20000A9
_0x20000A6:
	SUBI R18,-LOW(48)
_0x20000A9:
	SBRC R16,4
	RJMP _0x20000AB
	CPI  R18,49
	BRSH _0x20000AD
	__GETD2S 16
	__CPD2N 0x1
	BRNE _0x20000AC
_0x20000AD:
	RJMP _0x20000AF
_0x20000AC:
	CP   R20,R19
	BRSH _0x2000117
	CP   R21,R19
	BRLO _0x20000B2
	SBRS R16,0
	RJMP _0x20000B3
_0x20000B2:
	RJMP _0x20000B1
_0x20000B3:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x20000B4
_0x2000117:
	LDI  R18,LOW(48)
_0x20000AF:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x20000B5
	CALL SUBOPT_0x2E
	BREQ _0x20000B6
	SUBI R21,LOW(1)
_0x20000B6:
_0x20000B5:
_0x20000B4:
_0x20000AB:
	CALL SUBOPT_0x23
	CPI  R21,0
	BREQ _0x20000B7
	SUBI R21,LOW(1)
_0x20000B7:
_0x20000B1:
	SUBI R19,LOW(1)
	CALL SUBOPT_0x2F
	CALL __MODD21U
	CALL SUBOPT_0x28
	LDD  R30,Y+20
	__GETD2S 16
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __DIVD21U
	CALL SUBOPT_0x2D
	__GETD1S 16
	CALL __CPD10
	BREQ _0x20000A5
	RJMP _0x20000A4
_0x20000A5:
_0x20000A2:
	SBRS R16,0
	RJMP _0x20000B8
_0x20000B9:
	CPI  R21,0
	BREQ _0x20000BB
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL SUBOPT_0x26
	RJMP _0x20000B9
_0x20000BB:
_0x20000B8:
_0x20000BC:
_0x200005A:
_0x2000115:
	LDI  R17,LOW(0)
_0x200003B:
	RJMP _0x2000036
_0x2000038:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CALL __GETW1P
	CALL __LOADLOCR6
	ADIW R28,63
	ADIW R28,31
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	CALL __SAVELOCR4
	CALL SUBOPT_0x30
	SBIW R30,0
	BRNE _0x20000BD
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x20A0004
_0x20000BD:
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	MOVW R16,R26
	CALL SUBOPT_0x30
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G100)
	LDI  R31,HIGH(_put_buff_G100)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G100
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x20A0004:
	CALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET

	.CSEG

	.CSEG
_strcpyf:
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcpyf0:
	lpm  r0,z+
    st   x+,r0
    tst  r0
    brne strcpyf0
    movw r30,r24
    ret
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.CSEG
_ftrunc:
   ldd  r23,y+3
   ldd  r22,y+2
   ldd  r31,y+1
   ld   r30,y
   bst  r23,7
   lsl  r23
   sbrc r22,7
   sbr  r23,1
   mov  r25,r23
   subi r25,0x7e
   breq __ftrunc0
   brcs __ftrunc0
   cpi  r25,24
   brsh __ftrunc1
   clr  r26
   clr  r27
   clr  r24
__ftrunc2:
   sec
   ror  r24
   ror  r27
   ror  r26
   dec  r25
   brne __ftrunc2
   and  r30,r26
   and  r31,r27
   and  r22,r24
   rjmp __ftrunc1
__ftrunc0:
   clt
   clr  r23
   clr  r30
   clr  r31
   clr  r22
__ftrunc1:
   cbr  r22,0x80
   lsr  r23
   brcc __ftrunc3
   sbr  r22,0x80
__ftrunc3:
   bld  r23,7
   ld   r26,y+
   ld   r27,y+
   ld   r24,y+
   ld   r25,y+
   cp   r30,r26
   cpc  r31,r27
   cpc  r22,r24
   cpc  r23,r25
   bst  r25,7
   ret
_floor:
	CALL SUBOPT_0x31
	CALL __PUTPARD1
	CALL _ftrunc
	CALL __PUTD1S0
    brne __floor1
__floor0:
	CALL SUBOPT_0x31
	RJMP _0x20A0003
__floor1:
    brtc __floor0
	CALL SUBOPT_0x31
	__GETD2N 0x3F800000
	CALL __SUBF12
_0x20A0003:
	ADIW R28,4
	RET

	.CSEG
_ftoa:
	SBIW R28,4
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	STD  Y+2,R30
	LDI  R30,LOW(63)
	STD  Y+3,R30
	ST   -Y,R17
	ST   -Y,R16
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x208000D
	RCALL SUBOPT_0x32
	__POINTW1FN _0x2080000,0
	RCALL SUBOPT_0x16
	RJMP _0x20A0002
_0x208000D:
	CPI  R30,LOW(0x7FFF)
	LDI  R26,HIGH(0x7FFF)
	CPC  R31,R26
	BRNE _0x208000C
	RCALL SUBOPT_0x32
	__POINTW1FN _0x2080000,1
	RCALL SUBOPT_0x16
	RJMP _0x20A0002
_0x208000C:
	LDD  R26,Y+12
	TST  R26
	BRPL _0x208000F
	__GETD1S 9
	CALL __ANEGF1
	RCALL SUBOPT_0x33
	RCALL SUBOPT_0x34
	LDI  R30,LOW(45)
	ST   X,R30
_0x208000F:
	LDD  R26,Y+8
	CPI  R26,LOW(0x7)
	BRLO _0x2080010
	LDI  R30,LOW(6)
	STD  Y+8,R30
_0x2080010:
	LDD  R17,Y+8
_0x2080011:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x2080013
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x36
	RJMP _0x2080011
_0x2080013:
	RCALL SUBOPT_0x37
	CALL __ADDF12
	RCALL SUBOPT_0x33
	LDI  R17,LOW(0)
	__GETD1N 0x3F800000
	RCALL SUBOPT_0x36
_0x2080014:
	RCALL SUBOPT_0x37
	CALL __CMPF12
	BRLO _0x2080016
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x36
	SUBI R17,-LOW(1)
	CPI  R17,39
	BRLO _0x2080017
	RCALL SUBOPT_0x32
	__POINTW1FN _0x2080000,5
	RCALL SUBOPT_0x16
	RJMP _0x20A0002
_0x2080017:
	RJMP _0x2080014
_0x2080016:
	CPI  R17,0
	BRNE _0x2080018
	RCALL SUBOPT_0x34
	LDI  R30,LOW(48)
	ST   X,R30
	RJMP _0x2080019
_0x2080018:
_0x208001A:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x208001C
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x1D
	CALL __PUTPARD1
	CALL _floor
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x37
	CALL __DIVF21
	CALL __CFD1U
	MOV  R16,R30
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x20
	LDI  R31,0
	RCALL SUBOPT_0x35
	CALL __CWD1
	CALL __CDF1
	CALL __MULF12
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x33
	RJMP _0x208001A
_0x208001C:
_0x2080019:
	LDD  R30,Y+8
	CPI  R30,0
	BREQ _0x20A0001
	RCALL SUBOPT_0x34
	LDI  R30,LOW(46)
	ST   X,R30
_0x208001E:
	LDD  R30,Y+8
	SUBI R30,LOW(1)
	STD  Y+8,R30
	SUBI R30,-LOW(1)
	BREQ _0x2080020
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x33
	__GETD1S 9
	CALL __CFD1U
	MOV  R16,R30
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x20
	LDI  R31,0
	RCALL SUBOPT_0x38
	CALL __CWD1
	CALL __CDF1
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x33
	RJMP _0x208001E
_0x2080020:
_0x20A0001:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
_0x20A0002:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,13
	RET

	.DSEG

	.CSEG

	.DSEG
_t:
	.BYTE 0x4
_buff:
	.BYTE 0x28
__seed_G104:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 28 TIMES, CODE SIZE REDUCTION:78 WORDS
SUBOPT_0x1:
	ST   -Y,R30
	CALL _LCD_Commmand
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	JMP  _LCD_Goto

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(174)
	ST   -Y,R30
	JMP  _LCD_Commmand

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x4:
	CALL _i2c_start
	LDI  R30,LOW(120)
	ST   -Y,R30
	JMP  _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5:
	ST   -Y,R30
	CALL _i2c_write
	JMP  _i2c_stop

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6:
	LDD  R4,Y+1
	LDD  R3,Y+0
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDD  R30,Y+1
	SUBI R30,-LOW(176)
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(64)
	ST   -Y,R30
	CALL _i2c_write
	LDI  R17,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x8:
	LDI  R30,LOW(5)
	CALL __MULB1W2U
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	SUBI R30,LOW(-_LCD_Buffer*2)
	SBCI R31,HIGH(-_LCD_Buffer*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x9:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xA:
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	JMP  _LCD_Goto2X

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xB:
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	JMP  _LCD_Commmand

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xC:
	ST   -Y,R30
	CALL _LCD_Commmand
	LDI  R30,LOW(64)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0xD:
	LDI  R30,LOW(_buff)
	LDI  R31,HIGH(_buff)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xE:
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xF:
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _LCD_Printf
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x10:
	ST   -Y,R30
	CALL _LCD_Goto
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x11:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x12:
	LDS  R30,_t
	LDS  R31,_t+1
	LDS  R22,_t+2
	LDS  R23,_t+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x13:
	STS  _t,R30
	STS  _t+1,R31
	STS  _t+2,R22
	STS  _t+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x14:
	__GETD1N 0x3DCCCCCD
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x15:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x16:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _strcpyf

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x17:
	__GETD2S 4
	__GETD1N 0x41200000
	CALL __MULF12
	__PUTD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x18:
	__GETD1S 4
	__GETD2S 12
	CALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x19:
	__GETD2S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1A:
	RCALL SUBOPT_0x14
	CALL __MULF12
	__PUTD1S 12
	SUBI R19,-LOW(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1B:
	__GETD1N 0x41200000
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	__PUTD1S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1D:
	__GETD2N 0x3F000000
	CALL __ADDF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1E:
	RCALL SUBOPT_0x14
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1F:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,1
	STD  Y+8,R26
	STD  Y+8+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x20:
	MOV  R30,R16
	SUBI R30,-LOW(48)
	ST   X,R30
	MOV  R30,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x21:
	CALL __SWAPD12
	CALL __SUBF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x22:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,1
	STD  Y+8,R30
	STD  Y+8+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x23:
	ST   -Y,R18
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x24:
	__GETW1SX 90
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x25:
	SBIW R30,4
	__PUTW1SX 90
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x26:
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x27:
	__GETW2SX 90
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x28:
	__PUTD1S 10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x29:
	RCALL SUBOPT_0x24
	RJMP SUBOPT_0x25

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2A:
	__GETD1S 10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2B:
	STD  Y+14,R30
	STD  Y+14+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2C:
	RCALL SUBOPT_0x27
	ADIW R26,4
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2D:
	__PUTD1S 16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x2E:
	ANDI R16,LOW(251)
	LDD  R30,Y+21
	ST   -Y,R30
	__GETW1SX 87
	ST   -Y,R31
	ST   -Y,R30
	__GETW1SX 91
	ICALL
	CPI  R21,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2F:
	__GETD1S 16
	__GETD2S 10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x30:
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x31:
	CALL __GETD1S0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x32:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x33:
	__PUTD1S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x34:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x35:
	__GETD2S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x36:
	__PUTD1S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x37:
	__GETD1S 2
	__GETD2S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x38:
	__GETD2S 9
	RET


	.CSEG
	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,13
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,27
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_read3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_read3
	rcall __i2c_delay1
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_write3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_write3
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	rjmp __i2c_delay1

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF1211
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF1211:
	BRCC __ADDF128
	RJMP __ADDF129
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__ASRW4:
	ASR  R31
	ROR  R30
__ASRW3:
	ASR  R31
	ROR  R30
__ASRW2:
	ASR  R31
	ROR  R30
	ASR  R31
	ROR  R30
	RET

__CBD1:
	MOV  R31,R30
	ADD  R31,R31
	SBC  R31,R31
	MOV  R22,R31
	MOV  R23,R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__MULB1W2U:
	MOV  R22,R30
	MUL  R22,R26
	MOVW R30,R0
	MUL  R22,R27
	ADD  R31,R0
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVB21:
	RCALL __CHKSIGNB
	RCALL __DIVB21U
	BRTC __DIVB211
	NEG  R30
__DIVB211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODB21:
	CLT
	SBRS R26,7
	RJMP __MODB211
	NEG  R26
	SET
__MODB211:
	SBRC R30,7
	NEG  R30
	RCALL __DIVB21U
	MOV  R30,R26
	BRTC __MODB212
	NEG  R30
__MODB212:
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__CHKSIGNB:
	CLT
	SBRS R30,7
	RJMP __CHKSB1
	NEG  R30
	SET
__CHKSB1:
	SBRS R26,7
	RJMP __CHKSB2
	NEG  R26
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSB2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
